define(function(require, exports, module){
    var config = require('../apiConfig');

	var AddresCollection = Backbone.Collection.extend({
        url: config.apiUrl + '?r=customer.address.list',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    mobile_no: sessionStorage.mobile_no
                },
                success: function(data) {
                    if (data.success) {
                        addresses = data.addresses;
                        self.reset(data.addresses);
                    } else {
                        self.trigger("error");
                    }
                },
                error: function() {
                    self.trigger("error");
                }
            });
        }
    });

	module.exports = new AddresCollection();
})