define(function(require, exports, module){
    var config = require('../apiConfig');

	var GoodsCollection = Backbone.Collection.extend({
        url: config.apiUrl + '?r=store.product.list',
//        perpage: 5,
        sync: function(method, model, options) {
            var self = this;
            var offset=0;
            var perpage=6;
            if(options){
                offset= options.offset || offset;
                perpage=options.perpage || perpage;
            }
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    'mobile_no': sessionStorage.k,
                    'perpage':perpage,
                    'offset': offset
                },
                success: function(data) {
                    console.log(data);
                    if (data.success) {
                        // if (offset == 0) {
                        //     self.reset();
                        // };
                        self.productlength=data.cnt;
                        // console.log(data.product_list.length);
                        _(data.product_list).each(function(p) {
                            if(self.findWhere({"id": p.id})){
                            }
                            else{
                                p.amount = 0;
                                self.add(p);
                            }
                        });
                        self.trigger("reset");
                    } else {
                        self.trigger("error");
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    $('#loading').fadeOut(200, function() {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        }
    });

	module.exports = new GoodsCollection();
})