define(function(require, exports, module){
    var config = require('../apiConfig');

	var OrdersConnection = Backbone.Collection.extend({
        url: config.apiUrl + '?r=store.myorder.list',
        sync: function(method, model, options) {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    status: options.orderStatus
                },
                success: function(data) {
                    if (data.success) {
                        debugger;
                        self.reset(data.orders);
                    } 
                    else {
                        self.trigger("error", data);
                    }
                },
                error: function() {
                    self.trigger("error");
                }
            });
        },
        //格式化日期
        formatDate: function(date) {
            var sYear = date.getFullYear(),
                sMonth = (date.getMonth() + 1),
                sDate = date.getDate();
                                               
            sMonth = (sMonth < 10) ? ('0' + sMonth) : sMonth;
            sDate = (sDate < 10) ? ('0' + sDate) : sDate;
                                               
            var sDate = sYear + '-' + sMonth + '-' + sDate;

            return sDate;
        },
        // 初始化safeAjax的数据
        initPostDate: function() {
            var now = new Date();
            var beginDate = this.formatDate(now);

            //someDate.setDate(now.getDate() + 30); 
            var endDate2 = new Date();
            endDate2.setDate(now.getDate() + 30);

            var endDate = this.formatDate(endDate2);

            this.postData = {
                application: 'GetMyOrderList',
                beginDate: beginDate,
                endDate: endDate,
                mobileNo: context.user.mobileNo,
                page: '',
                pageSize: ''
            }
        }
        // // 数据请求失败后，改回原来的hash值
        // goBackUrl: function() {
        //     app_router.navigate('!index', {trigger: false});
        // }
    });

	module.exports = new OrdersConnection();
})