define(function(require, exports, module){
    var config = require('../apiConfig');

	var ProductCollection = Backbone.Collection.extend({
        url: config.apiUrl+ '?r=sdk.product.search',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    keyword: sessionStorage.keyword
                },
                success: function(data) {
                    if (data.success) {
                        self.reset(data.products);
                    } else {
                        self.trigger("error");
                    }
                },
                error: function() {
                    self.trigger("error");
                    $('#loading').fadeOut(200, function(e) {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        }
    });

	module.exports = new ProductCollection();
})