define(function(require, exports, module){
	var config = require('../apiConfig');
    Backbone.emulateHTTP = true;

	var Address = Backbone.Model.extend({
        url: config.apiUrl + '?r=customer.address.create',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'post',
                data: this.attributes,
                success: function(data) {
                    if (data.success) {
                        self.trigger("saved", data.address);
                    } else {
                        self.trigger("error", data);
                    }
                },
                error: function(err) {
                    self.trigger("error");
                }
            });
        }
    });

	module.exports = Address;
});