define(function(require, exports, module) {
    var config = require('../apiConfig');

    var Order = Backbone.Model.extend({
        url: config.apiUrl + '?r=store.order.submit',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'post',
                data: {
                    mobile_no: sessionStorage.mobile_no,
                    payer_id: context.user.mobileNo,
                    detail: JSON.stringify(this.get('detail')),
                    amount: this.get('amount'),
                    needexpress: this.get('needexpress'),
                    address: JSON.stringify(this.get('selectedAddress') || ""),
                    memo: $("#settlement .msg").val()
                },
                success: function(data) {
                    debugger;
                    if (data.success) {
                        $('#loading').fadeOut(200);
                        self.order = data.order;
                        self.trigger('changed');

                        //self.requestOrder(data.order);
                    } else {
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    debugger;
                    $('#loading').fadeOut(200, function() {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        }
    });

    module.exports = new Order();
});