define(function(require, exports, module) {
    var config = require('../apiConfig');


    var OrderDetail = Backbone.Model.extend({
        url: config.apiUrl + '?r=store.myorder.detail',
        sync: function(method, model, options) {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    order_id: options.order_id
                },
                success: function(data) {
                    if (data.success) {
                        orderInfo = data.order;
                        orderDetailsView.render(data);
                        //显示页面
                        require.async('../nav', function(nav) {
                            nav.init(curStep);
                        });
                        $('#loading').fadeOut(200);
                    } else {
                        self.goBackUrl();
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    self.goBackUrl();
                    $('#loading').fadeOut(200, function(e) {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        goBackUrl: function() {
            switch (curStep) {
                case '1':
                    app_router.navigate('!myWeidian/1', {trigger: false});
            }
        }
    });

    module.exports = new OrderDetail();
});