define(function(require, exports, module) {
  var utils = require('../utils');
  var Homepage = require('../views/homepage');
  var Dian = require('../views/dian');
  var cur_page;

    var AppRouter = Backbone.Router.extend({
        initialize: function() {
            this.history = [];
        },

        routes: {
            '': 'homepage',
            '!homepage': 'homepage',
            '!homepage': 'homepage',
            '!dian': 'dian',
            '!dian.category': 'diancategory',
            '!dian.service': 'dianservice',
            '!settle': 'settle',

            '!selectaddress/:addressId': 'selectaddress',
            '!createaddress': 'createaddress',


            '!dian.product': 'dianproduct',
            '!addproduct/:step': 'addproduct',
            '!searchproduct': 'searchproduct',

            '!order.my': 'ordermy',
            '!order.detail/:id': 'orderdetail',

        },

        ordermy: function() {
            this.switchPage('ordermy');
        },

        orderdetail: function(id) {
            this.switchPage('orderdetail');
        },

        switchPage: function(page){
            app.views[page].getView().trigger("reset");

            //var nav = app.rootView.getRegion("content").$el.find(".nav")
            //app.rootView.getRegion("nav").html();
            //setTimeout(function(){
                //app.rootView.getRegion("content").$el.find(".panel").hide();
                //app.rootView.getRegion("content").$el.find("#" + page).show();

            app.rootView.getRegion("content").$el.find(".panel:visible").fadeOut();
            app.rootView.getRegion("content").$el.find("#" + page).fadeIn();
            
            utils.adjustPlatform();

            //});
            
        },
        homepage: function() {
            this.switchPage('homepage');
            //app.rootView.getRegion("content").attachView(app.views.dian.getView());
            // app.views.homepage.getView().render();
            // setTimeout(function(){
            //     app.rootView.getRegion("content").$el.find(".panel").hide();
            //     app.rootView.getRegion("content").$el.find("#homepage").show();
            // });
        },
        dian: function() {
            this.switchPage('dian');
            //app.rootView.getRegion("content").attachView(app.views.dian.getView());
            // console.log("sss");
            // console.log(app.rootView.getRegion("content").$el.find('.panel'))
            // app.views.dian.getView().render();
            // setTimeout(function(){
            //     app.rootView.getRegion("content").$el.find('.panel').hide();
            //     app.rootView.getRegion("content").$el.find("#dian").show();
            // }, 1000);
        },
        dianproduct: function() {
            this.switchPage('dianproduct');
        },

        diancategory: function(){
            this.switchPage('diancategory');
        },
        dianservice: function(){
            this.switchPage('dianservice');
        },

        settle: function(step) {
            this.switchPage('settle');
        },

        searchproduct: function() {
            console.log("switch to search product");
            this.switchPage('searchproduct');
        },

        orders: function(step) {
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/orders', function(orders) {
                step = step || '';
                orders.init(step);
            });
        },
        showOrderDetail: function(step) {
            require.async('./visitWeidian/orderDetails', function(orderDetail) {
                orderDetail.init(step);
            });
        },

        

        /**** Address  *****/
        selectaddress: function(addressId) {
            console.log("switch to select address");
            this.switchPage('selectaddress');
        },

        createaddress: function() {
            console.log("switch to create address");
            this.switchPage('createaddress');
        },
        /***** End address ****/

        newproduct: function(step) {
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/newproduct', function(newproduct) {
                newproduct.init(step);
            });
        },
        

        before: function(route, view) {
            if (cur_page&&cur_page.unrender)
              cur_page.unrender();
        },
        after: function(){
            this.storeRoute();
        },
        storeRoute: function(){ 
            if (!app.router.ignore) {
                var re = /[a-zA-Z]+\/[\d|new]/; // matches, eg. "quotes/5" or "quotes/new"
                if (!this.history.length) {
                    var parts = Backbone.history.fragment.split('/'),
                        len = parts.length,
                        i = 0;
            
                    while (i < len) {
                        this.history.push(parts.slice(0, i + 1).join('/'));
                        i++;
                    }
                } else {
                    this.history.push(Backbone.history.fragment);
                }
            } else {
                app.router.ignore = false;
            }
            //console.log(this.history);
        },

        route: function(route, name, callback) {
          //debugger;
          Backbone.history || (Backbone.history = new Backbone.History);
          if (!_.isRegExp(route)) route = this._routeToRegExp(route);
          if (!callback) callback = this[name];
          Backbone.history.route(route, _.bind(function(fragment) {
            var that = this;
            var args = this._extractParameters(route, fragment);
            if (_(this.before).isFunction()) {
              this.before.apply(this, args);
            }
            if (callback) callback.apply(that, args);
            if (_(this.after).isFunction()) {
              this.after.apply(this, args);
            }
          }, this));
        },
        back: function() {
            app.router.ignore = true;
            if (this.history.length > 1) {
                window.history.back();
                // this.navigate(this.history[this.history.length - 2], {
                //     trigger: true
                // });
                this.history = this.history.slice(0, -1);
            }
        },
        backTo: function(route, options) {
            options = options || {}
            app.router.ignore = options.ignore || true;

            var historyIndex = this.history.indexOf(route);
            if(historyIndex < 0) {
                historyIndex = 0;
            }
            //window.history.go(historyIndex - this.history.length);
            
            if (this.history.length > 1) {
                window.history.go(historyIndex - this.history.length + 1);
                // this.navigate(this.history[historyIndex], {
                //     trigger: true
                // });
                this.history = this.history.slice(0, historyIndex+1);
            }

        }

    });

    module.exports = AppRouter;

});
