// 所有模块都通过 define 来定义
define(function(require, exports) {

    // 对外提供 foo 属性
    exports.adjustPlatform = function() {
      if(typeof device !== 'undefined') {
        if (device.platform == 'Android') {
            $('nav, #trolley_layer, #steps').addClass('android');
            $('#loading').addClass('android').height($('body').height() - 46);
            $('.content').css('padding-top','46px');
        }
        else if (device.platform == 'iOS') { 
            $('.leftButton').removeClass('hide');
            if (device.version < "7.0") {
                $('nav, #trolley_layer, #steps').addClass('notIOS7');
                $('#loading').addClass('notIOS7').height($('body').height() - 46);
            } else {
                $('#loading').height($('body').height() - 66);
            }
        }
        
      }else{
            $('nav, #trolley_layer, #steps').addClass('android');
            $('#loading').addClass('android').height($('body').height() - 46);
            $('.content').css('padding-top','46px');
      }
      if( navigator && navigator.notification) {
        // 替换web的弹框为本地弹框
        window.alert = navigator.notification.alert;
        window.confirm = navigator.notification.confirm;
      }
      new FastClick(document.body); // 消除click事件在触摸UI上的点击延迟
    };

    exports.changePage = function(domid) {
      $('#content').children().fadeOut(0, function() {
          $('#content '+domid).show(300);
      });
    };

    // 对外提供 doSomething 方法
    exports.getFormattedDate = function(date) {
        var year = date.getFullYear();
        var month = (1 + date.getMonth()).toString();
        month = month.length > 1 ? month : '0' + month;
        var day = date.getDate().toString();
        day = day.length > 1 ? day : '0' + day;

        var hours = date.getHours().toString();
        hours = hours.length > 1 ? hours : '0' + hours;

        var minutes = date.getMinutes().toString();
        minutes = minutes.length > 1 ? minutes : '0' + minutes;

        return year + '-' + month + '-' + day + " " + hours + ":" + minutes;

    };
    //show hideloading
    exports.showloading=function(){
        $("#loadings").fadeIn();
    };

    //hide hidebody
    exports.hideloading=function(){
        $("#loadings").fadeOut();
    };

});