define(function(require, exports, module) {
    var config = require('../apiConfig');

    Address = require('../models/address');

    var CreateAddressView = Marionette.ItemView.extend({
        el: '#createaddress',
        template: '#createaddress-template',

        model: Address,

        _renderProvinces: function(){
            var provinces = "上海市,江苏省,浙江省,江西省,天津市,安徽省,河南省,四川省,湖南省,福建省,广西省,海南省,广东省,甘肃省,重庆市,贵州省,云南省,宁夏,陕西省,山西省,湖北省,河北省,山东省,内蒙古,北京市,吉林省,辽宁省,黑龙江省,西藏,新疆,青海省".split(",");
            var provinces_select = $("select[name='province']");
            provinces_select.empty();
            provinces_select.append( "<option value=''>请选择省份</option>");
            for (var i = provinces.length - 1; i >= 0; i--) {
                provinces_select.prepend( "<option value='"+provinces[i]+"'>"+provinces[i]+"</option>");
            }
        },

        serializeData: function(){
            var data = {}; //this.model.toJSON();
            data.le = sessionStorage.le;
            data.amount = sessionStorage.amount;
            return data;
        },

        onRender: function(){
            this._renderProvinces();
            this.$el.isHappy({
                    submitButton: '#submitAddress',
                    fields: {
                        '#address_name': {
                            required: true,
                            message: '请填入收件人姓名'
                        },
                        '#address_tel': {
                            required: true,
                            message: '请填入正确的收件人联系手机号',
                            test: happy.mobile
                        },
                        '#address_province': {
                            required: true,
                            message: '请填入收件人所在省'
                        },
                        '#address_address': {
                            required: true,
                            message: '请填入收件人详细地址'
                        }
                    }
            });
        },

        initialize: function() {
            var self = this;
            //this.model.on('change', this.render, this);
            //this.model.on('saved', this.saved, this);
        },

        events: {
            'click a.save_btn': 'save_address',
            'click nav .backBtn': 'back'
        },

        back: function(e) {
            app.router.back();
        },

        save_address: function(e) {
            var obj = $(e.currentTarget);

            Backbone.emulateHTTP = true;

            var address = new Address({
                name: this.$(".input[name='name']").val(),
                tel: this.$(".input[name='tel']").val(),
                province: this.$("select[name='province']").val(),
                address: this.$("textarea[name='address']").val(),
                city: ""
            });
            address.save();
            address.on('saved', function(add){
                window.selectedAddress = add;
                $("#form_addaddress").get(0).reset();
                app.router.back();
            });
            address.on('error', function(data){
                debugger;
            });
        }
    })

    var _view = null;
    
    // 对外提供 foo 属性
    //exports.View = HomepageView;
    module.exports = {
        getView: function() {
            if(_view == null) {
                _view = new CreateAddressView({
                  //model: Address
                });
                _view.render();
            }
            //console.log(_view);
            return _view;
        }
    }
});
