define(function(require, exports, module) {
    var config = require('../apiConfig');

    AddressCollection = require('../collections/address');

    var SelectAddressView = Marionette.ItemView.extend({
        el:'#selectaddress',
        template: '#selectaddress-template',

        data: {},

        events:{
            //'tap .add':'add',
            'click nav .backBtn': 'back',
            'click a.save_btn': 'save_address',
            'click .right_delete':'addressDelete',
            'click .addresslist li': 'addressSelect',
            'swipeLeft .addresslist li': 'showDelete',
            'longTap .addresslist li  > div': 'showDeleteHack'
        },

        back: function(e) {
            app.router.back();
        },

        serializeData: function(){
            var data = this.data;
            data.selectedAddress = window.selectedAddress;
            data.items = this.collection.toJSON();
            return data;
        },

        initialize: function() {
            var self = this;
            this.on('reset', function() {
                self.collection.fetch();
            });
            this.collection.on('reset', function() {
                self.render();
            });
        },

        add:function(){
            //app.router.navigate('!addaddress/0',{trigger:true});
        },

        showDelete: function(e) {
            var obj = $(e.currentTarget);
            obj.find('.modify, .delete').addClass('moveLeft');
            debugger;
        },

        showDeleteHack: function(e) {
            var self = this;
            confirm('', function(index) {
                if (index == 1) {
                    self.addressDelete(e, 2);
                }
            }, '请选择', ['删除联系人']);
            debugger;
        },

        addressSelect: function(e) {
            debugger;
            var obj = $(e.currentTarget);
            if ($(e.target).hasClass('right_delete')) {
                return;
            };
            $(".active_mark").removeClass("active");
            obj.find(".active_mark").addClass("active");
            this.setGlobalAddress(obj.data('id'));
        },

        setGlobalAddress: function(addressId) {
            debugger;
            window.selectedAddress = null;
            if (addressId == null) {
                return;
            }
            for (var i = addresses.length - 1; i >= 0; i--) {
                if(addressId == addresses[i].id) {
                    window.selectedAddress = addresses[i];
                }
            }
        },

        addressDelete: function(e) {
            var self = this;
            var obj = $(e.currentTarget);
            var addressId = obj.parents("li").data("id");
            obj.parents("li").hide();
            if (addressId == null) {
                return;
            }
            debugger;
            $.ajax({
                url: config.apiUrl + '?r=customer.address.remove',
                type: 'post',
                data: {
                    "address_id": addressId
                },
                success: function(data) {
                    if (data.success) {
                        if (window.selectedAddress && window.selectedAddress.id == addressId) {
                            self.setGlobalAddress(null);
                        };
                        self.collection.fetch();
                        $('#loading').fadeOut(200);
                    } else {
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {
                                self.collection.fetch();
                            }, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    $('#loading').fadeOut(200, function() {
                        alert(data.msg || '请检查当前网络', function() {
                            self.collection.fetch();
                        }, '提示', '确定');
                    });
                }
            });
        },

        chose:function(e){
            
        },

    });

    var _view = null;
    
    // 对外提供 foo 属性
    //exports.View = HomepageView;
    module.exports = {
        getView: function() {
            if(_view == null) {
                _view = new SelectAddressView({
                  collection: AddressCollection
                });
                _view.render();
            }
            //console.log(_view);
            return _view;
        }
    }
});
