define(function(require, exports, module) {
    var config = require('../apiConfig');

    CategoryCollection = require('../collections/category');

    var DianCategoryView = Marionette.ItemView.extend({
        el:'#diancategory',
        template: '#diancategory-template',

        events:{
            'click #categorylist li': 'choose',
            'click .searchbtn': 'toSearchList',
            'click nav .backBtn': 'back',
        },

        initialize: function() {
            this.collection.on('reset', this.render, this);
            this.collection.fetch();
        },
        choose:function(e) {
            var obj = $(e.currentTarget);
            var keyword = obj.find(".goods_name").html();
            if (keyword == '服务') {
                app.router.navigate('!dian.service', {trigger: true});
            }
            else {
                sessionStorage.keyword = keyword;
                app.router.navigate('!searchproduct', {trigger: true});
            }
        },
        back: function(e) {
            app.router.back();
        },

        toSearchList: function() {
            var keyword = this.$('input.menu_ele').val();
            if (keyword == '') {
                alert('请输入商品关键字', function() {}, '提示');
            }
            else {
                sessionStorage.keyword = keyword;
                app.router.navigate('!searchproduct', {trigger: true});
            }
        }

    });
    
    var _view = null;
    // 对外提供 foo 属性
    //exports.View = HomepageView;
    module.exports = {
        getView: function() {
            if (_view == null) {
                _view = new DianCategoryView({
                    collection: CategoryCollection,
                });
                _view.render();
            }
            return _view;
        }
    }
});
