define(function(require, exports, module) {
    var config = require('../apiConfig');

    GoodsCollection = require('../collections/goods');
    Dian = require('../views/dian');

    var DianProductView = Marionette.ItemView.extend({
        el:'#dianproduct',
        template: '#dianproduct-template',

        events:{
            'click nav .backBtn': 'back',
            'click .goods_list li': 'choose',
            'click .searchbtn': 'toSearchList'
        },

        back: function(e) {
            app.router.back();
        },

        initialize: function() {
            this.collection.on('reset', this.renderPriductList, this);
            this.collection.fetch();
        },

        renderPriductList: function(){
            var self = this;
            var tmpl = _.template($('#dianproductlist-template').html(), {items: self.collection.toJSON()});
            this.$('#productlist').html(tmpl);
        },
        
        toSearchList: function() {
            var keyword = this.$('input.menu_ele').val();
            if (keyword == '') {
                alert('请输入商品关键字', function() {}, '提示');
            }
            else {
                sessionStorage.keyword = keyword;
                app.router.navigate('!searchproduct', {trigger: true});
            }
        },

        choose:function(e){
            var obj = $(e.currentTarget);
            var id = parseInt(obj.attr('data-id'));
            var product = this.collection.findWhere({'id': id});
            var dianView = Dian.getView();
            dianView.addtocart(product.toJSON(), 1);

            app.router.backTo('!dian');
        },

    });
    
    var _view = null;
    // 对外提供 foo 属性
    //exports.View = HomepageView;
    module.exports = {
        getView: function() {
            if (_view == null) {
                _view = new DianProductView({
                    model: DianModel,
                    collection: GoodsCollection,
                });
                _view.render();
            }
            return _view;
            
        }
    }
});
