define(function(require, exports, module) {
    var config = require('../apiConfig');

    MarketCollection = require('../collections/market');
    UserModel = require('../models/user');
    Dian = require('../views/dian');

    // var skInfo = null;
    // var step = 1;

    var HomepageView = Marionette.ItemView.extend({
        el: '#homepage',
        template: '#homepage-template',
        markets: MarketCollection,
        nIntervId: null,
        user: new UserModel(),
        initialize: function () {
            this.listenTo(this.model, 'change', this.render);
            this.listenTo(this.model, 'destroy', this.remove);
            this.listenTo(this.model, 'visible', this.toggleVisible);
            this.listenTo(this.markets, 'reset', this.renderMarkets, this);
            this.markets.fetch();
            this.user.fetch();
        },

        onRender: function(){
            this.renderHistoryPhone();
        },

        renderMarkets: function(){
            if(this.markets.length == 0) {
                return;
            }
            var data = {},
                first = this.markets.at(0);

            app.datanum.marketname = first.shopName;
            localStorage.appUser = first.shopAppUser;
            localStorage.le = this.markets.length;

            if(localStorage.le <= 1){
                localStorage.appUser = context.appuser;
                $(".marketes").hide();
                $(".sort_area").css("margin-top",'30px');
            }
            var tmpl = _.template($("#marketslist-template").html(),{items:this.markets.toJSON()});
            $(".marketslist").html(tmpl);
            $(".marketslist").find("li:first .img_b a").trigger("click")
        },
        events: {
            'click nav .backBtn': 'back',
            'click .searchbtn': 'search',
            'click .sear2': 'getContactsInfo',
            'touchstart .sear': 'taped',
            'touchend .sear': 'notap',
            'touchstart .global_button': 'taped',
            'touchend .global_button': 'notap',
            'click .img_b a':'marketname',
            'longTap .phones_list li': 'deleteMe',
            'click .phones_list li': 'changeValue'
        },
        back: function(e) {
            context.quit();
        },

        deleteMe: function(evt) {
            debugger;
            var thetext=$(evt.currentTarget).text();
            var arr;
           
            if (localStorage.seek_record) {
                arr = JSON.parse(localStorage.seek_record);
                Array.prototype.indexOf = function(val) {
                    for (var i = 0; i < this.length; i++) {
                       if (this[i] == val) {
                        return i;
                        }
                    }
                       return -1;
                };
                Array.prototype.remove = function(val) {
                    var index = this.indexOf(val);
                    if (index > -1) {
                        this.splice(index, 1);
                    }
                };
               
                arr.remove(thetext);
                localStorage.seek_record = JSON.stringify(arr);
                this.renderHistoryPhone();
            }
        },

        getContactsInfo: function() {
            var self = this;
            window.plugins.ContactChooser.chooseContact(
                function(contactInfo) {
                    self.$('input.menu_ele').val(contactInfo.phoneNumber);
                    self.search();
                }
            );
        },

        renderTitle: function(){
            var tmpl = _.template(this.$('.nav').html());

            app.rootView.getRegion("nav").html(tmpl);
        },

        // 判断是否显示下拉联想列表
        renderHistoryPhone: function() {
            //console.log("render History Phone");
            var historyList = [];
            if (localStorage.seek_record) {
                historyList = JSON.parse(localStorage.seek_record);
            }
            var tmpl = _.template($('#phones_list').html(), {phones: historyList});
            
            this.$('.phones_list').html(tmpl);
        },

        marketname: function(e) {
            var aa = $(e.currentTarget);
            var i=0;
            $(".marketslist").find("a").removeClass("actived");
            aa.addClass("actived");
            app.datanum.marketname = aa.find(".strong").html();
            localStorage.appUser = aa.data('appuser');
        },


        search: function() {
            var reg = /^[0-9]+$/,
                fd_id = this.$('input.menu_ele').val();
            if (fd_id == '') {
                alert('请输入收款人手机号/福店ID', function() {}, '提示');
            } else if (!reg.test(fd_id)) {
                alert('输入格式有误，请检查', function() {}, '提示');
            } else {
                if(sessionStorage.k != fd_id) {
                    Dian.getView().trigger("cleanup");
                }
                sessionStorage.k = fd_id;

                app.router.navigate('!dian', {trigger: true});

                // 存储用户搜索福店记录，用于输入框联想
                var ls_sr = localStorage.seek_record;
                if (!ls_sr) {
                    ls_sr = localStorage.seek_record = '[]';
                } else {
                    var j_ls_sr = JSON.parse(ls_sr);
                    for (i=j_ls_sr.length; i; i--) {
                        if (j_ls_sr[i-1] == fd_id) {
                            return;
                        }
                    }
                }

                var temp = JSON.parse(ls_sr);
                temp.push(fd_id);
                localStorage.seek_record = JSON.stringify(temp);
                this.renderHistoryPhone();
            }
        },

        changeValue: function(e) {
            var aa = $(e.currentTarget);
            this.$('.menu_ele').val($(e.target).text());
            $(".phones_list").find("li").removeClass("activeds");
            aa.addClass("activeds");
            this.search();
        },

        taped: function(e) {
            var obj = $(e.target);
            obj.addClass('taped');
        },

        notap: function(e) {
            var obj = $(e.target);
            obj.removeClass('taped');
        }, 
    });
    var _view = null;
    
    // 对外提供 foo 属性
    module.exports = {
        getView: function() {
            if(_view == null) {
                _view = new HomepageView();
                _view.render();
            }
            console.log(_view);
            return _view;
        }
    }

});
