define(function(require, exports, module) {
    var config = require('../apiConfig');
    var utils = require('../utils');

    var orderStatus = 3;

    OrderCollection = require('../collections/order');

    var OrderMyView = Marionette.ItemView.extend({
        el: '#ordermy',
        template: "#ordermy-template",
                                           
        initialize: function() {
            var self = this;
            this.on('reset', function() {
                this.collection.fetch({"orderStatus": orderStatus});
                self.render();
            });

            this.collection.on('reset', function() {
                self.renderOrderList();
            });

            this.collection.on('error', function() {
                debugger;
            });
        },
        events: {
            'click .order': 'toDetailView',
            'click .first': 'listOrder',
            'click .second': 'listOrder',
            'click .third': 'listOrder',
            'click .last': 'listOrder',
            'click nav .backBtn': 'back',
        },

        back: function(e) {
            app.router.back();
        },

        onRender: function(){
            this.renderOrderList();
        },

        renderOrderList: function(){
            _.template.formatdate = function (stamp) {
                return utils.getFormattedDate(stamp);
            };
            var tmpl = _.template($('#orders_list_template').html(), {collection: this.collection.toJSON()});
            
            this.$('.orders_list').html(tmpl);

            if (orderStatus == 3) {
                if (this.collection.length == 0) {
                    this.$('.orders_no').hide();
                }
                else if (this.collection.length > 20) {
                    this.$('.orders_no').text("20+").show();
                }
                else {
                    this.$('.orders_no').text(this.collection.length).show();
                }
            }
        },

        listOrder: function(e) {
            var obj = $(e.currentTarget);
            obj.parent().children().removeClass('actived');
            obj.addClass('actived');
            orderStatus = obj.data('status');
            this.collection.fetch({"orderStatus":orderStatus});
        },

        toDetailView: function(e) {
            // var obj = $(e.currentTarget);
            // sessionStorage.order_id = obj.attr('data-id');
            // app.router.navigate('!order.detail/' + sessionStorage.order_id, {trigger: true});
        },
    });

    var _view = null;
    
    module.exports = {
        getView: function() {
            if(_view == null) {
                _view = new OrderMyView({
                  collection: OrderCollection
                });
                _view.render();
            }
            return _view;
        }
    }
});
