define(function(require, exports, module) {
    var config = require('../apiConfig');
    var utils = require('../utils');
    ProductCollection = require('../collections/product');

    var DianProductView = Marionette.ItemView.extend({
        el:'#searchproduct',
        template: '#searchproduct-template',

        events:{
            'click #producttype li': 'choose',
            'click .searchbtn': 'toSearchList',
            'click nav .backBtn': 'back',
        },
        back: function(e) {
            utils.hideloading();
            app.router.back();
        },
        initialize: function() {
            var self = this;
            this.on('reset', function(){
                utils.showloading();
                // utils.adjustPlatform();
                self.collection.fetch();
            });
            this.collection.on('reset', this.render);
            // this.collection.on('reset', utils.hideloading); 
            this.collection.on('error', function(){
                self.collection.reset();
                self.render();
            });
            this.collection.on('error', utils.hideloading());
            this.listenTo(this.collection, 'reset', utils.hideloading);
             this.listenTo(this.collection, 'reset', utils.adjustPlatform);
        },

        toSearchList: function() {
            var keyword = this.$('input.menu_ele').val();
            if (keyword == '') {
                alert('请输入商品关键字', function() {}, '提示');
            }
            else {
                sessionStorage.keyword = keyword;
                this.collection.fetch();
            }
        },

        choose:function(e){
            var obj = $(e.currentTarget);
            var tp = _.find(this.collection.models, function(p){
                return (p.get('id') + "") == obj.attr('data-id'); 
            });
            var product = {
                    "id": "tmp-" + tp.id,
                    "price": tp.get('spprice'),
                    "name": tp.get('spname'),
                    "url": tp.get('spurl'),
                    "image_src": tp.get('sppic'),
                    "amount":1,
            };
            
            var dianView = app.views.dian.getView();
            dianView.addtocart(product, 1);

            app.router.backTo("!dian");
        },
    });

    var _view = null;
    
    // 对外提供 foo 属性
    //exports.View = HomepageView;
    module.exports = {
        getView: function() {
            if (_view == null) {
                _view = new DianProductView({
                    collection: ProductCollection
                });
                _view.render();
            }
            return _view;
            
        }
    }


});
