define(function(require, exports, module) {
    var config = require('../apiConfig');
    Dian = require('../views/dian');
    var utils = require('../utils');
    OrderModel = require('../models/order');

    var SettleView = Marionette.ItemView.extend({
        el: '#settle',

        template: '#settle-template',

        data: {},

        serializeData: function(){
            this.data.le = sessionStorage.le;
            this.data.amount = sessionStorage.amount;
            this.data.marketname = app.datanum.marketname;
            this.data.dian = Dian.getView().model;
            return this.data;
        },

        initialize: function () {
            var self = this;
            this.listenTo(this, 'reset', function(){
                self.render();
            });

             this.listenTo(this.model, 'changed', function(){
                self.requestOrder(this.model.order);
            });
        },

        requestOrder: function(data) {
            if (this.model.get('buytype') == null) {
                alert("订单已过期，请返回后首页后重新下单");
                return;
            }
            utils.hideloading();
            jfpal.jfPay({
                "needHandsign": '1',
                "merchantId": "0002000002",
                "merchantName": '福店',
                "productId": this.model.get('buytype'),
                "orderAmt": (this.model.get('amount') * 100).toFixed(0) + '',
                "orderDesc": sessionStorage.mobile_no, //微店主手机号
                "orderRemark": localStorage.appUser + "," + data.id //flagship_id,order_id  更改内容
            }, function(o) {
                app.router.backTo('!homepage', {
                    trigger: true
                });
            }, function() {
                
            });
        },

        onRender: function(){
            var self = this;
            if (sessionStorage.buytype == "0000000000") {
                pId = '0000000000';
                context.helpinfo('PersonalPayments.PayWaySuper', function(data){
                    self.$('.notice').html(data);
                    self.$('#payway').html('会员批发');
                });
            }
            if (sessionStorage.buytype == "0000000002") {
                pId = '0000000002';
                context.helpinfo('PersonalPayments.PayWayCommon', function(data){
                    self.$('.notice').html(data);
                    self.$('#payway').html('会员零购');
                });
            }
            this.renderOrderDetail();
            this.renderAddress();
        },

        events: {
            'click nav .backBtn': 'back',
            'click .global_button': 'settle',
            //'click .fourth span': 'chsStyle',
            'touchstart .global_button': 'taped',
            'touchend .global_button': 'notap',
            'touchstart .pub_goods': 'taped',
            'touchend .pub_goods': 'notap',
            'click .delivery .right':'switchDelivery',
            'click .address':'toaddress'
        },

        back: function(e) {
            utils.hideloading();
            app.router.back();
        },

        // initialize: function() {
        //     var self = this;
        // },

        //shopTrl: '',
 
        // render: function(data) {
        //     this.$('.last').html(this.template(data));
            
        //     this.shopTrl = data;

        //     this.render_bottom(data);

        //     if (sessionStorage.buytype == "0000000000") {
        //         pId = '0000000000';
        //         context.helpinfo('PersonalPayments.PayWaySuper', function(data){
        //             $('.notice').html(data);
        //             $('#payway').html('会员批发');
        //         });
        //     }
        //     if (sessionStorage.buytype == "0000000002") {
        //         pId = '0000000002';
        //         context.helpinfo('PersonalPayments.PayWayCommon', function(data){
        //             $('.notice').html(data);
        //             $('#payway').html('会员零购');
        //         });
        //     }
        // },

        renderOrderDetail: function() {
            var tmpl = _.template($('#orderdetail-template').html(), {items:  JSON.parse(sessionStorage.products)});
            this.$('.orderdetail').html(tmpl);
        },

        renderAddress: function() {
            var data = {
                "name": "",
                "tel": "",
                "privince": "",
                "address": "",
            };
            if (window.selectedAddress) {
                $("#settle .right").addClass("open");
                $("#settle .address").show();
                data = window.selectedAddress;
            }
            else {
                $("#settle .right").removeClass("open");
                $("#settle .address").hide();
            }
            var tmpl = _.template($('#address-template').html(), {address: data});
            this.$('.address').html(tmpl);
            
        },


        switchDelivery:function(e){
            var obj = $(e.currentTarget);
            if (obj.hasClass('open')) {
                obj.removeClass("open");
                $("#settle .address").hide();
            }
            else {
                app.router.navigate('!selectaddress/0', {trigger:true});
            }
        },

        settle: function() {
            var i = 0;
            var detail = [];
            $.each( JSON.parse(sessionStorage.products), function(key, value) {
                if(value.amount>0){
                    detail[i] = [];
                    detail[i][0] = value['id'];
                    detail[i][1] = value['price'];
                    detail[i][2] = value.amount;
                    detail[i][3] = value;
                    i += 1;
                }
            });
            
            var productAmount = parseInt($('.order_price, .trolley_icon > span').text());
            if (productAmount < 10 && sessionStorage.buytype == '0000000000') {
                alert('购买10件商品以上才可享受批发优惠', function() {}, '提示', '确定');
                return;
            }
            utils.showloading();
            this.model.set('detail', detail);
            this.model.set('amount', this.data.amount);
            this.model.set('needexpress', $("#settlement .right").hasClass("open") ? "1" : "0");
            this.model.set('selectedAddress', window.selectedAddress);
            this.model.set('buytype', sessionStorage.buytype);
            this.model.save();
        },

        chsStyle: function(e) {
            //
            
        },

        taped: function(e) {
            var obj = $(e.target);
            obj.addClass('taped');
        },

        notap: function(e) {
            var obj = $(e.target);
            obj.removeClass('taped');
        },

        

        toaddress:function(e){
            var obj = $(e.currentTarget);
            app_router.navigate('!selectaddress/' + $(obj).data('address_id'), {trigger:true});
        }
        
    });

    var _view = null;
    
    // 对外提供 foo 属性
    //exports.View = HomepageView;
    module.exports = {
        getView: function() {
            if (_view == null) {
                _view = new SettleView({
                    model: OrderModel,
                    collection: JSON.parse(sessionStorage.products),
                });
                _view.render();
            }
            return _view;
            
        }
    }

});
