define(function(require,exports,module){
	require('./config');
	require('./jfpal-config');
	(function() {

        // 弹出等待层时，禁止滚动
        $(window).on('touchmove', function(e) {
            if ($('#loading').css('display') == 'block') {
                e.preventDefault();
            }
        });

        // 替换web的弹框为本地弹框
        window.alert = navigator.notification.alert;
        window.confirm = navigator.notification.confirm;

        if (device.platform == 'Android') {
            $('nav,#steps,.search,.abclist, .top-bar').addClass('android');
            $('#loading').height($(window).height() - 46); // 设置此页等待层的高度
            window.pFlag = 'android'; // 平台标志位
        } else if (device.platform == 'iOS') {
            $('.leftButton').removeClass('hide');
            if (device.version < "7.0") {
                $('nav, #steps,.search,.abclist, .top-bar').addClass('notIOS7');
                $('#loading').height($(window).height() - 46); // 设置此页等待层的高度
            } else {
                $('#loading').height($(window).height() - 66); // 设置此页等待层的高度
            }
            window.pFlag = 'ios'; // 平台标志位
        }

        // 创建全局对象dT,方便在各个view之间传递数据
        window.dT = {
            amt:100,
            gameList:{
                json:''//缓存游戏列表
            },
            companyList:{
                json:''//缓存公司列表
            },
            httpData:{
                token:'token',
                clienttype:'android',
                clientversion:'1.0',
                infversion:'1.0',
                merchantIP:'192.168.1.100'
            },
            leftSource:'',//返回 1:游戏列表 2:公司详情
            orderSource:'',//返回 1:游戏详情 2:订单列表
            companyGame:{
                companyId:'',
                companyName:''
            },
            gameDetail:{
                gameId:'',
                gameName:''
            },
            orderList:{
                orderid:'',
                gameName:'',
                json:'',//订单列表缓存
                cache:false
            },
            orderDetail:{
                orderAmt:'',
                goodsId:'',
                orderId:'',
                ptorderno:''
            },
            addOrder:{
                goodsId:'',
                gameId:'',
                gameAccount:'',
                gameWow:'',
                gameAreaId:'',
                gameServerId:'',
                accountType:'',
                chargeType:'',
                buyNum:'1'
            },
            errorCode:{
                GC99:'服务器异常'
            }
        };

        window.database = openDatabase('listtitle', '1.0', '游戏公司表', 1024 * 1024);




    })();

    var AppRouter = Backbone.Router.extend({
        routes: {
            '': 'indexGame',
            '!indexGame/:step': 'indexGame',
            '!indexCompany/:step': 'indexCompany',
            '!companyGame/:step': 'companyGame',
            '!gameDetail/:step': 'gameDetail',
            '!orderList/:step': 'orderList',
            '!orderDetail/:step': 'orderDetail',
            '!payResult/:step': 'payResult',
            '!listView/:step': 'listView'
        },

        indexGame: function(step) {
            var step = step || '';
            require.async('./rechargeablecard/listTitle', function(listView) {
                listView.init(step);
            });
            require.async('./rechargeablecard/gameList', function(gameList) {
                gameList.init(step);
            });
        },
        indexCompany: function(step) {
            require.async('./rechargeablecard/companyList', function(companyList) {
                companyList.init(step);
            });
        },
        companyGame: function(step) {
            require.async('./rechargeablecard/companyGame', function(companyGame) {
                companyGame.init(step);
            });
        },
        gameDetail: function(step) {
            require.async('./rechargeablecard/gameDetail', function(gameDetail) {
                gameDetail.init(step);
            });
        },
        orderList: function(step) {
            require.async('./rechargeablecard/orderList', function(orderList) {
                orderList.init(step);
            });
        },
        orderDetail: function(step) {
            require.async('./rechargeablecard/orderDetail', function(orderDetail) {
                orderDetail.init(step);
            });
        },
        payResult: function(step) {
            require.async('./rechargeablecard/payResult', function(payResult) {
                payResult.init(step);
            });
        },
        listView: function(step) {
            require.async('./rechargeablecard/listTitle', function(listView) {
                listView.init(step);
            });
        }





    });

    window['app_router'] = new AppRouter;
    Backbone.history.start();


});
