define(function(require, exports, module) {
    // 不同的view，触发不同的hash
    var leftHash = '';
    var rightHash = '';

    function goBack() {
        $('#loading').fadeOut(200); // 点击返回，隐藏网络请求等待层
        if (leftHash != '') {
//            alert(leftHash);
            location.hash = leftHash;

        } else {
            context.quit();
        }
    }

    //左侧返回按钮点击事件
    if (device.platform == 'iOS') {
        $('nav .leftButton').on('click', goBack);
    } else if (device.platform == 'Android') {
        document.addEventListener('backbutton', goBack, false);
    }

    //右侧按钮点击事件
    $('nav .rightButton').on('click', function() {
        location.hash = rightHash;
    });

    //导航条两侧点击效果
    $('.leftButton, .rightButton, #gameDetail menu .next_btn,#orderDetail menu button,#payResult .return_index_btn').on('touchstart', function() {
        $(this).addClass('taped');
    });
    $('.leftButton, .rightButton, #gameDetail menu .next_btn,#orderDetail menu button,#payResult .return_index_btn').on('touchend', function() {
        $(this).removeClass('taped');
    });

    C.Config = $.extend(C.Config, {
        leftBar: function(state) {
            switch (state) {
                case 'indexGame':
                    leftHash = '';
                    break;
                case 'indexCompany':
                    leftHash = '';
                    break;
                case 'companyGame':
                    leftHash = '!indexCompany/2';
                    break;
                case 'gameDetail':
                    if(1==window.dT.leftSource){//返回游戏列表
                        leftHash = '!indexGame/1';
                    }else if(3==window.dT.leftSource){//返回公司
                        leftHash = '!companyGame/3';
                    }

                    break;
                case 'orderList':
                    if(2==window.dT.leftSource){//返回公司
                        leftHash = '!indexCompany/2';
                    }else{//返回游戏列表
                        leftHash = '!indexGame/1';
                    }
                    break;
                case 'orderDetail':
                    if(1==window.dT.orderSource){
                        leftHash = '!gameDetail/4';
                    }else if (2==window.dT.orderSource) {
                        leftHash = '!orderList/5';
                    }
                    break;



            }
        },

        rightBar: function(state) {
            switch (state) {
                case 'indexGame':
                    rightHash = '!orderList/5';
                    $('nav .rightButton').css('visibility', 'visible').text('订单');
                    break;
                case 'indexCompany':
                    rightHash = '!orderList/5';
                    $('nav .rightButton').css('visibility', 'visible').text('订单');
                    break;
                case 'companyGame':
                    rightHash = '';
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'gameDetail':
                    rightHash = '';
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'orderList':
                    rightHash = '';
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'payResult':
                    rightHash = '';
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;

            }
        },

        // 根据相应页面改变导航条
        setToolBar: function(hash, step, title) {
            if ((step == '') || hash.match('indexGame')) {
                $('nav .navTitleMain').css('display','block');
                $('nav .navTitle').css('visibility','hidden');
                C.Config.leftBar('indexGame');
                C.Config.rightBar('indexGame');
                $('.li_1').removeClass('focus');
                $('.li_2').removeClass('focus');
            }else if (hash.match('indexCompany')) {
                $('nav .navTitleMain').css('display','block');
                $('nav .navTitle').css('visibility','hidden');
                C.Config.leftBar('indexCompany');
                C.Config.rightBar('indexCompany');
                $('.li_2').addClass('focus');
                $('.li_1').addClass('focus');
            }else if (hash.match('companyGame')) {
                $('nav .navTitleMain').css('display','none');
                $('nav .navTitle').css('visibility','visible').text(window.dT.companyGame.companyName);
                C.Config.leftBar('companyGame');
                C.Config.rightBar('companyGame');
            }else if (hash.match('gameDetail')) {
                $('nav .navTitleMain').css('display','none');
                $('nav .navTitle').css('visibility','visible').text(window.dT.gameDetail.gameName);
                C.Config.leftBar('gameDetail');
                C.Config.rightBar('gameDetail');
            }else if (hash.match('orderList')) {
                $('nav .navTitleMain').css('display','none');
                $('nav .navTitle').css('visibility','visible').text('订单列表');
                C.Config.leftBar('orderList');
                C.Config.rightBar('orderList');
            }else if (hash.match('orderDetail')) {
                $('nav .navTitleMain').css('display','none');
                $('nav .navTitle').css('visibility','visible').text('我的订单');
                C.Config.leftBar('orderDetail');
                C.Config.rightBar('orderDetail');
            }else if (hash.match('payResult')) {
                $('nav .navTitleMain').css('display','none');
                $('nav .navTitle').css('visibility','visible').text(window.dT.orderList.gameName);
                C.Config.leftBar('payResult');
                C.Config.rightBar('payResult');
            }
        }
    });

    $(".li_1").on("click",function(){
        app_router.navigate('!indexGame/1', {trigger: true});
        window.dT.leftSource = 1;
        $('.li_1').removeClass('focus');
        $('.li_2').removeClass('focus');
    });
    $(".li_2").on("click",function(){
        app_router.navigate('!indexCompany/2', {trigger: true});
        window.dT.leftSource = 2;
        $('.li_2').addClass('focus');
        $('.li_1').addClass('focus');
    });


});