define(function(require) {
    var curStep;
    var tempId;

    var ComGames = Backbone.Collection.extend({
        sync: function() {
            var self = this;
            if(isDebug){
                self.isFirstTime(0);
            }
            if(isProxy){
                jfpal.proxyAjax('', {"application": "GC0002",
                        "bizTypeCode": "GC",
                        "merchantId":"0004000018",
                        "param": {method: 'queryGameInfo',
                            clienttype: window.dT.httpData.clienttype,
                            clientversion: window.dT.httpData.clienttype,
                            infversion:window.dT.httpData.infversion,
                            token:window.dT.httpData.token,
                            com_id:window.dT.companyGame.companyId}
                    },
                    function(data) {
//                    alert(data);
                        console.log(data);
                        if(data.param.data.resstate=="0") {
                            self.isFirstTime(1, data.param.data);
                        }else{
                            if(data.param.data.rescode=="GC99"){
                                alert(window.dT.errorCode.GC99);
                            }
                        }
                    },
                    function(data){
                        alert("queryGameInfo error");
                        console.log(data);
                    });
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'queryGameInfo',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token,
                                com_id:window.dT.companyGame.companyId}
                        ),
                        dataType:"json",
                        success:function(data){
                            self.isFirstTime(1,data);
                        },
                        error: function (xhr,type) {
                            self.isFirstTime(0);
                        }
                    }
                );
            }



        },

        isFirstTime: function(state, data) {
            var self = this;
            if (state == 0) {
                $.getJSON('../json/QueryCompanyGame.json', function(data) {
                    self.fillData(data);
                });
            } else {
                self.fillData(data);
            }
        },

        // 本地数据库的相关操作
        fillData: function(data) {
            var self = this;
            self.reset(data.game_list);
            require.async('../nav', function(nav) {
                nav.init(curStep);
            });
            $('#loading').fadeOut(200);
        },



        // 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
//            app_router.navigate('!indexCompany', {trigger: false});
        }
    });

    var ComGameView = Backbone.View.extend({
        el: '#com_game',

        collection: new ComGames(),

        initialize: function () {
            var self = this;
            this.collection.on('reset', function() {
                self.render(0);
            });
        },

        template: function(collection) {
            var temp = _.template($('#company_game_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(state, data) {
            if (state == 0) {
                this.$('#com_game_list').html(this.template(this.collection.toJSON()));
            } else {
                this.$('#com_game_list').html(this.template(data));
            }
        },


        events: {
            'tap #com_game_list div': 'toGameDetail'
        },

        toGameDetail: function(e){
            var obj = $(e.currentTarget);
            window.dT.gameDetail.gameId = obj.attr("alt");
            window.dT.addOrder.gameId = obj.attr("alt");
            window.dT.gameDetail.gameName = obj.text();
            window.dT.leftSource = 3;//返回公司详情
            app_router.navigate('!gameDetail/4', {trigger: true});
        }
    });


    var comGameView = new ComGameView();

    return {
        init: function(step) {
            // 初始化相关数据
            curStep = step;
//            tempId = com_id;
            $('#com_game_list').html('');

//            $('#loading').fadeIn(200);
            comGameView.collection.fetch();
        }
    };
});