define(function(require) {
    var curStep;

    var Companies = Backbone.Collection.extend({
        sync: function() {
            var self = this;
            if(isDebug){
                self.isFirstTime(0);
            }

            if(isProxy){
                if(window.dT.companyList.json!=''){
                    self.isFirstTime(1,window.dT.companyList.json);
                }else{
                jfpal.proxyAjax('', {"application": "GC0001",
                        "bizTypeCode": "GC",
                        "merchantId":"0004000018",
                        "param": {method: 'queryGameCompany',
                            clienttype: 'android',
                            clientversion: 1.0,
                            infversion:1.0,
                            token:'token'}
                    },
                    function(data) {
                        console.log(data);
                        if(data.param.data.resstate=="0") {
                            if (window.dT.companyList.json == '') {
                                self.isFirstTime(1, data.param.data);
                            } else {
                                $('#loading').fadeOut(200);
                            }
                            window.dT.companyList.json = data.param.data;
                        }else{
                            if(data.param.data.rescode=="GC99"){
                                alert(window.dT.errorCode.GC99);
                            }
                            setTimeout(function(){
                                context.quit();
                            },1500);
                        }
                    },
                    function(data){
                        alert("公司列表请求失败。请检查网络!");
                        console.log(data);
                        $('#loading').fadeOut(200);
                        setTimeout(function(){
                            context.quit();
                        },1500);
                    });
                }
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'queryGameCompany',
                                clienttype: 'android',
                                clientversion: 1.0,
                                infversion:1.0,
                                token:'token'}
                        ),
                        dataType:"json",
                        success:function(data){
                            self.isFirstTime(1,data);
                        },
                        error: function (xhr,type) {
                            self.isFirstTime(0);
                        }
                    }
                );
            }


        },

        isFirstTime: function(state, data) {
            var self = this;
            if (state == 0) {
                $.getJSON('../json/QueryCompanyAll.json', function(data) {
                    self.fillData(data);
                });
            } else {
                self.fillData(data);
            }
        },

        // 本地数据库的相关操作
        fillData: function(data) {
            var self = this;
            if (window.database) {
                window.database.transaction(function(tx) {
                    tx.executeSql('create table if not exists companyList (id unique, companyname text, companyid text)');
                    tx.executeSql('delete from companyList');
                    var j=0;
                    $.each(data.com_list, function(key, value) {
                        tx.executeSql('insert into companyList (id, companyname, companyid) values(?, ?, ?)', [j+'', value.com_name, value.com_id]);
                        j++;
                    });
//                    app_router.navigate('!listView/9', {trigger: true});
//                    self.reset(data.com_list);
//                    require.async('../nav', function(nav) {
//                        nav.init(curStep);
//                    });
//                    $('#loading').fadeOut(200);
                });
            }
            self.reset(data.com_list);
            require.async('../nav', function(nav) {
                nav.init(curStep);
            });
            $('#loading').fadeOut(200);
        },



        // 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
//            app_router.navigate('!indexCompany', {trigger: false});
        }
    });

    var CompanyView = Backbone.View.extend({
        el: '#company',

        collection: new Companies(),

        initialize: function () {
            var self = this;
            this.collection.on('reset', function() {
                self.render(0);
            });
        },

        template: function(collection) {
            var temp = _.template($('#company_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(state, data) {
            if (state == 0) {
//                alert(this.collection.toJSON());
                this.$('.companyList').html(this.template(this.collection.toJSON()));
            } else {
                this.$('.companyList').html(this.template(data));
            }
        },


        events: {
            'tap .companyList li': 'toIndex'
        },

        toIndex: function(e){
            var obj = $(e.currentTarget);
            window.dT.companyGame.companyId = obj.attr("alt");
            window.dT.companyGame.companyName = obj.text();
            app_router.navigate('!companyGame/3', {trigger: true});

        }

    });


    var companyView = new CompanyView();

    return {
        init: function(step) {
            // 初始化相关数据
            curStep = step;
            $('#company .getCompany').val('');
            $('#company .list').html('');
//            $('#company').show();
            $('.getCompany').val("");
            $('#search_c .list').fadeOut(0);
            if(window.dT.companyList.json=='') {
                $('#loading').fadeIn(200);
            }
            companyView.collection.fetch();
        }
    };
});