define(function(require) {
    var curStep;
    var tempId;

    var cur_goods;
    var cur_account_type;
    var cur_area;

    // 对应模块需要不需要显示
    var flagGoodList = true;
    var flagAccountType = true;
    var flagChargeType = true;
    var flagAreaList = true;
    var flagArea1List = true;
    // 对应模块需要不需要显示

    // 1:没有,可不显示。0:有信息,需要 用list里面的数据
    var isaccount;
    var ischarge;
    var isarea;
    var isserver;
    // 1:没有,可不显示。0:有信息,需要 用list里面的数据


    //当price为1时的充值份数
    var buy_number_flag;//是否需要填写份数
    var price;
    var buy_number_mul;
    var buy_number_min;
    var buy_number_max;
    var total;


    var GameDetail = Backbone.Collection.extend({
        sync: function() {
            var self = this;
            if(isDebug){
                self.isFirstTime(0);
            }
            console.log("gameid: "+window.dT.gameDetail.gameId);

            if(isProxy){
                jfpal.proxyAjax('', {"application": "GC0004",
                        "bizTypeCode": "GC",
                        "merchantId":"0004000018",
                        "param": {method: 'queryGoodsDecsByGameid',
                            clienttype: window.dT.httpData.clienttype,
                            clientversion: window.dT.httpData.clienttype,
                            infversion:window.dT.httpData.infversion,
                            token:window.dT.httpData.token,
                            gameid:window.dT.gameDetail.gameId
                        }
                    },
                    function(data) {
//                    alert(data);
                        console.log(data);
                        if(data.param.data.resstate=="0") {
                            self.isFirstTime(1, data.param.data);
                        }else{
                            if(data.param.data.rescode=="GC99"){
                                alert(window.dT.errorCode.GC99);
                            }
                        }
                    },
                    function(data){
                        alert("queryGoodsDecsByGameid error");
                        console.log(data);
                        $('#loading').fadeIn(200);
                    });
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'queryGoodsDecsByGameid',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token,
                                gameid:window.dT.gameDetail.gameId
                            }
                        ),
                        dataType:"json",
                        success:function(data){
                            self.isFirstTime(1,data);
                        },
                        error: function (xhr,type) {
                            self.isFirstTime(0);
                        }
                    }
                );
            }


        },

        isFirstTime: function(state, data) {
            var self = this;
            if (state == 0) {
                $.getJSON('../json/GameDetail.json', function(data) {
                    self.fillData(data);
                });
            } else {
                self.fillData(data);
            }
        },

        // 本地数据库的相关操作
        fillData: function(data) {
            var self = this;
            self.reset(data.goods_list);
            require.async('../nav', function(nav) {
                nav.init(curStep);
            });
            $('#loading').fadeOut(200);
        },



        // 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
//            app_router.navigate('!indexCompany', {trigger: false});
        }
    });

    var GameDetailView = Backbone.View.extend({
        el: '#gameDetail',

        collection: new GameDetail(),


        initialize: function () {
            var self = this;
            this.collection.on('reset', function() {
                self.render(0);
            });
        },

        template: function(collection) {
            var temp = _.template($('#game_detail_goodlist_tpl').html(), {collection: collection});
            return temp;
        },
        numTemplate: function(collection) {
            var temp = _.template($('#game_detail_num_tpl').html(), {collection: collection});
            return temp;
        },
        accountTypeTemplate: function(collection) {
            var temp = _.template($('#game_detail_accounttype_tpl').html(), {collection: collection});
            return temp;
        },
        rechargeTypeTemplate: function(collection) {
            var temp = _.template($('#game_detail_rechargetype_tpl').html(), {collection: collection});
            return temp;
        },
        areaTemplate: function(collection) {
            var temp = _.template($('#game_detail_area_tpl').html(), {collection: collection});
            return temp;
        },
        area1Template: function(collection) {
            var temp = _.template($('#game_detail_area_1_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(state, data) {
            if (state == 0) {
                this.initView();
                this.initData();
                this.$('.cost_select').html(this.template(this.collection.toJSON()));
                this.changePrice($('.cost_select').val(),$('.cost_select').find('option:selected').attr("alt"));
            } else {
                this.$('.cost_select').html(this.template(data));
            }
        },

        events: {
            'change .cost_select': 'doChangeCost',
            'change .area_select': 'doChangeArea',
            'change .area_select_1': 'doChangeArea1',
            'change .account_type_select': 'doChangeAccountType',
            'change .recharge_type_select': 'doChangeRechargeType',
            'tap .next_btn':'submitOrder',
            'input #buy_numberInput':'validBuyNumber'
        },

        initView: function(){
            this.$('#account_type').css('display','none');
            this.$('.num_form').css('display','none');
            this.$('#num_line').css('display','none');
            this.$('#area').css('display','none');
            this.$('#recharge_type').css('display','none');
            this.$('#area_1').css('display','none');
            this.$('#account_type_line').css('display','none');
            this.$('#area_line').css('display','none');
            this.$('#recharge_type_line').css('display','none');
            this.$('#area_1_line').css('display','none');
            this.$('#buy_number').css('display','none');
            this.$('#buy_numberInput').text("");
            this.$('#buy_number_line').css('display','none');
        },

        initData: function(){
            window.dT.addOrder.buyNum="1";
        },

        doChangeCost: function(e){
            var obj = $(e.currentTarget);
            this.changePrice(obj.val(),obj.find('option:selected').attr("alt"));
        },
        doChangeNum: function(e){
            var obj = $(e.currentTarget);
            this.changeNum(obj.val(),obj.find('option:selected').attr("alt"));
        },

        doChangeArea: function(e){
            var obj = $(e.currentTarget);
            this.changeArea(obj.val(), obj.find('option:selected').attr("alt"));
        },
        doChangeArea1: function(e){
            var obj = $(e.currentTarget);
            this.changeArea1(obj.val(), obj.find('option:selected').attr("alt"));
        },

        doChangeAccountType: function(e){
            var obj = $(e.currentTarget);
            this.changeAccountType(obj.val(), obj.find('option:selected').attr("alt"));
        },
        doChangeRechargeType: function(e){
            var obj = $(e.currentTarget);
            this.changeRechargeType(obj.val(), obj.find('option:selected').attr("alt"),
                obj.find('option:selected').attr("buy_number_mul"),
                obj.find('option:selected').attr("buy_number_min"),
                obj.find('option:selected').attr("buy_number_max"));
        },

        //提交订单
        submitOrder: function(e){
            window.dT.orderSource = 1;
            if($('#gameAccountInput').val().trim()==''){
                alert("请输入游戏账号", function() {}, '提示', '确定');
                return;
            }
            if(buy_number_flag && $('#buy_numberInput').val().trim()==''){
                alert("请输入购买份数", function() {}, '提示', '确定');
                return;
            }
            if(buy_number_flag){
                window.dT.addOrder.buyNum = total+"";
            }
            console.log(JSON.stringify(
                {method: 'goodsTransGetOrderNo',
                    clienttype: window.dT.httpData.clienttype,
                    clientversion: window.dT.httpData.clienttype,
                    infversion:window.dT.httpData.infversion,
                    token:window.dT.httpData.token,
                    userid:context.user.id,
                    goods_id:window.dT.addOrder.goodsId,
                    game_id:window.dT.addOrder.gameId,
                    gameAccount:$('#gameAccountInput').val().trim(),
                    gamewow:window.dT.addOrder.gameWow,
                    gameAreaID:window.dT.addOrder.gameAreaId,
                    gameServerID:window.dT.addOrder.gameServerId,
                    accountType:window.dT.addOrder.accountType,
                    chargeType:window.dT.addOrder.chargeType,
                    buyNum:window.dT.addOrder.buyNum,
                    merchantIP:window.dT.httpData.merchantIP
                }));

            if(isProxy){
                $('#loading').fadeIn(200);
                jfpal.proxyAjax('', {"application": "GC0005",
                        "bizTypeCode": "GC",
                        "merchantId":"0004000018",
                        "param": {method: 'goodsTransGetOrderNo',
                            clienttype: window.dT.httpData.clienttype,
                            clientversion: window.dT.httpData.clienttype,
                            infversion:window.dT.httpData.infversion,
                            token:window.dT.httpData.token,
                            userid:context.user.id,
                            goods_id:window.dT.addOrder.goodsId,
                            game_id:window.dT.addOrder.gameId,
                            gameAccount:$('#gameAccountInput').val().trim(),
                            gamewow:window.dT.addOrder.gameWow,
                            gameAreaID:window.dT.addOrder.gameAreaId,
                            gameServerID:window.dT.addOrder.gameServerId,
                            accountType:window.dT.addOrder.accountType,
                            chargeType:window.dT.addOrder.chargeType,
                            buyNum:window.dT.addOrder.buyNum,
                            merchantIP:window.dT.httpData.merchantIP
                        }
                    },
                    function(data) {
//                    alert(data);
                        $('#buy_numberInput').val("");
                        console.log(data);
//                    self.isFirstTime(1,data.param.data);
                        window.dT.orderList.orderid=data.param.data.orderid;
                        window.dT.orderDetail.ptorderno=data.param.data.ptOrderNo;
                        if(data.param.data.resstate=="0"){
                            app_router.navigate('!orderDetail/6', {trigger: true});
                        }else{
                            if(data.param.data.rescode=="GC99"){
                                alert(window.dT.errorCode.GC99);
                            }
                            $('#loading').fadeOut(200);
                        }
                    },
                    function(data){
                        alert("queryGameCompany error");
                        $('#loading').fadeOut(200);
                        console.log(data);
                    });
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'goodsTransGetOrderNo',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token,
                                userid:context.user.id,
                                goods_id:window.dT.addOrder.goodsId,
                                game_id:window.dT.addOrder.gameId,
                                gameAccount:$('#gameAccountInput').val().trim(),
                                gamewow:window.dT.addOrder.gameWow,
                                gameAreaID:window.dT.addOrder.gameAreaId,
                                gameServerID:window.dT.addOrder.gameServerId,
                                accountType:window.dT.addOrder.accountType,
                                chargeType:window.dT.addOrder.chargeType,
                                buyNum:window.dT.addOrder.buyNum,
                                merchantIP:window.dT.httpData.merchantIP
                            }
                        ),
                        dataType:"json",
                        success:function(data){
//                        self.isFirstTime(1,data);
                            window.dT.orderList.orderid=data.orderid;
                            window.dT.orderDetail.ptorderno=data.ptOrderNo;
                            if(data.resstate=="0"){
                                app_router.navigate('!orderDetail/6', {trigger: true});
                            }
                        },
                        error: function (xhr,type) {
//                        self.isFirstTime(0);
                        }
                    }
                );
            }

//            app_router.navigate('!orderDetail/6', {trigger: true});
        },

        //改变充值金额
        changePrice:function(value,alt) {
            this.initView();
            this.initData();
            $('.cost_form_cost').text(value);
            price = value.substring(1);//充值金额
            buy_number_flag = (price=="1.0" || price=="1");//需要填写份数
//            alert(price);
//            buy_number_flag = (price=="100" || price=="100.0");//需要填写份数
            window.dT.addOrder.goodsId =alt;

//            this.$('.account_type_select').html(this.template(this.collection.toJSON()));
            var flag = false;//有无goods
            _.each(this.collection.toJSON(), function (value1, key1) {
                flag = true;
                if (alt == value1.goods_id) {
                    cur_goods = value1;
                }
            });
            if(!flag){
                alert("此游戏暂不提供充值!", function() {}, '提示', '确定');
                flagGoodList = false;
                $('#loading').fadeOut(200);
                app_router.navigate('!indexGame/1', {trigger: true});
//                goBack();
                return;
            }

            isaccount = cur_goods.isaccount;
            ischarge = cur_goods.ischarge;
            isarea = cur_goods.isarea;
            isserver = cur_goods.isserver;
            console.log("is ==>  "+isaccount+":"+ischarge+":"+isarea+":"+isserver);

            //初始化帐号类型列表

            var tempFlag = true;//是否有账号类型数据
            if (cur_goods.game_account_type_list.length != 0) {
                if (isaccount == "1") {
//                    if ('' == cur_goods.game_account_type_list[0].game_account_type_name.trim()) {
                        flagAccountType = false;
//                    }else{
//                        flagAccountType = true;
//                    }
                }else{
                    flagAccountType = true;
                }
            }else{
                flagAccountType = false;
                tempFlag = false;
            }
            if(tempFlag) {
                this.$('.account_type_select').html(this.accountTypeTemplate(cur_goods.game_account_type_list));
                this.changeAccountType($('.account_type_select').val(), $('.account_type_select').find('option:selected').attr("alt"));
                if (flagAccountType) {
                    this.$('#account_type').css('display', 'block');
                    this.$('#account_type_line').css('display', 'block');
                } else {
                    this.$('#account_type').css('display', 'none');
                    this.$('#account_type_line').css('display', 'none');
                }
            }else{
                this.$('#account_type').css('display', 'none');
                this.$('#account_type_line').css('display', 'none');
            }

            //初始化大区列表
            if (cur_goods.game_arealist.length != 0) {
                flagAreaList = true;
            }else{
                flagAreaList = false;
            }
            if (flagAreaList) {
                this.$('#area').css('display','block');
                this.$('#area_line').css('display','block');
                this.$('.area_select').html(this.areaTemplate(cur_goods.game_arealist));
                this.changeArea($('.area_select').val(), $('.area_select').find('option:selected').attr("alt"));
            }else{
                this.$('#area').css('display','none');
                this.$('#area_line').css('display','none');
            }
        },

        //改变充值帐号类型
        changeAccountType:function(value,alt){
            $('.account_type').text(value);
            window.dT.addOrder.accountType =alt;
            _.each(cur_goods.game_account_type_list, function (value1, key1) {
                if (alt == value1.game_account_type_id) {
                    cur_account_type = value1;
                }
            });
            //初始化充值类型列表
            if ( cur_account_type.game_charge_type_list.length != 0) {
                if (ischarge=="1") {
//                    if ('' == cur_account_type.game_charge_type_list[0].game_charge_type_name.trim()) {
                        flagChargeType = false;
//                    }else{
//                        flagChargeType = true;
//                    }
                }else{
                    flagChargeType = true;

                }
            }else{
                flagChargeType = false;
            }
            if(flagChargeType){
                this.$('#recharge_type').css('display','block');
                this.$('#recharge_type_line').css('display','block');
                this.$('.recharge_type_select').html(this.rechargeTypeTemplate(cur_account_type.game_charge_type_list));
                this.changeRechargeType($('.recharge_type_select').val(),
                    $('.recharge_type_select').find('option:selected').attr("alt"),
                    $('.recharge_type_select').find('option:selected').attr("buy_number_mul"),
                    $('.recharge_type_select').find('option:selected').attr("buy_number_min"),
                    $('.recharge_type_select').find('option:selected').attr("buy_number_max")
                );
            }else{
                if(buy_number_flag){
                    this.showBuyNumber(cur_account_type.game_charge_type_list[0].buy_number_mul,
                        cur_account_type.game_charge_type_list[0].buy_number_min,
                        cur_account_type.game_charge_type_list[0].buy_number_max);
                }
                this.$('#recharge_type').css('display','none');
                this.$('#recharge_type_line').css('display','none');

            }

        },

        //打开填写份数的层
        showBuyNumber: function (buy_number_mul_t,buy_number_min_t,buy_number_max_t) {
            buy_number_mul = buy_number_mul_t;
            buy_number_min = buy_number_min_t;
            buy_number_max = buy_number_max_t;
            console.log("buy_number:1==>   "+buy_number_mul+":"+buy_number_min+":"+buy_number_max);
            this.$('#buy_number').css('display','block');
            this.$('#buy_number_line').css('display','block');

            $('.cost_form_cost').text("￥"+buy_number_mul);

        },

        validBuyNumber:function(){
            var val = $('#buy_numberInput').val();
            if(val==""){
                $('.cost_form_cost').text("￥"+buy_number_mul);
                return;
            }

            var numTemp = parseInt(val);
            if (isNaN(numTemp) || !isFinite(numTemp)) {
                alert("请输入数字!",function() {}, '提示', '确定');
                $('#buy_numberInput').val("");
                return;
            }
            total = parseInt(buy_number_mul)*numTemp;
            var m = buy_number_max/buy_number_mul;
            if(numTemp<1 || numTemp>m){
                alert("最多买"+m+"份哦亲!",function() {}, '提示', '确定');
                $('.cost_form_cost').text("￥"+buy_number_mul);
                $('#buy_numberInput').val("");
                return;
            }
            $('.cost_form_cost').text("￥"+total);
        },

        //改变充值类型
        changeRechargeType: function (value,alt,buy_number_mul_t,buy_number_min_t,buy_number_max_t) {
            $('.recharge_type').text(value);
            window.dT.addOrder.chargeType =alt;
            this.showBuyNumber(buy_number_mul_t,buy_number_min_t,buy_number_max_t);
        },
        //改变大区
        changeArea: function (value,alt) {
            $('.area_text').text(value);
            window.dT.addOrder.gameAreaId =alt;
            _.each(cur_goods.game_arealist, function (value1, key1) {
                if (alt == value1.game_area_id) {
                    cur_area = value1;
                }
            });
            //初始化服务器列表
            if (cur_area.game_server_list.length != 0) {
                flagArea1List = true;
            }else{
                flagArea1List = false;
            }
            if(flagArea1List){
                this.$('#area_1').css('display','block');
                this.$('#area_1_line').css('display','block');
                this.$('.area_select_1').html(this.area1Template(cur_area.game_server_list));
                this.changeArea1($('.area_select_1').val(), $('.area_select_1').find('option:selected').attr("alt"));
            }else{
                this.$('#area_1').css('display','none');
                this.$('#area_1_line').css('display','none');
            }

        },
        //改变服务器
        changeArea1: function (value,alt) {
            $('.area_1_text').text(value);
            window.dT.addOrder.gameServerId =alt;
        }
    });


    var gameDetailView = new GameDetailView();

    return {
        init: function(step) {
            // 初始化相关数据
            curStep = step;
//            tempId = com_id;
//            $('#gameDetail').html('');
//            require.async('../nav', function(nav) {
//                nav.init(curStep);
//            });
            $('#loading').fadeIn(200);
            gameDetailView.collection.fetch();
        }
    };
});