define(function(require) {
    var curStep;

    // app首次启动,本地存储游戏列表版本号
    if (!localStorage.version) {
        localStorage.version = '1.2';
    }
    // 连接数据库
//    var dataBase = openDatabase('gameList', '1.0', '游戏列表', 1024 * 1024);

    var Games = Backbone.Collection.extend({
        sync: function() {
            var self = this;
            if(isDebug){
                self.isFirstTime(0);
            }
            console.log(yqUrl+JSON.stringify(
                {method: 'queryGameAll',
                    clienttype: window.dT.httpData.clienttype,
                    clientversion: window.dT.httpData.clienttype,
                    infversion:window.dT.httpData.infversion,
                    token:window.dT.httpData.token}));
            if(isProxy){
                if(window.dT.gameList.json!=''){
                    self.isFirstTime(1,window.dT.gameList.json);
                }else{
                    jfpal.proxyAjax('', {"application": "GC0003",
                            "bizTypeCode": "GC",
                            "merchantId":"0004000018",
                            "param": {method: 'queryGameAll',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token}
                        },
                        function(data) {
                            console.log(data);
                            if(data.param.data.resstate=="0"){
                                if(window.dT.gameList.json==''){
                                    self.isFirstTime(1,data.param.data);
                                }else{
                                    $('#loading').fadeOut(200);
                                }
                                window.dT.gameList.json = data.param.data;
                            }else{
                                if(data.param.data.rescode=="GC99"){
                                    alert(window.dT.errorCode.GC99);
                                }
                                setTimeout(function(){
                                    context.quit();
                                },1500);

                            }

                        },
                        function(data){
                            alert("游戏列表请求失败。请检查网络!");
                            console.log(data);
                            $('#loading').fadeOut(200);
                            setTimeout(function(){
                                context.quit();
                            },1500);
                        });
                }
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'queryGameAll',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token}
                        ),
                        dataType:"json",
                        success:function(data){
                            console.log("success:"+data);
                            self.isFirstTime(1,data);
                        },
                        error: function (xhr,type) {
                            console.log("error:"+type);
                            console.log(JSON.stringify(xhr));
//                        alert(xhr);
                            self.isFirstTime(0);
                        }
                    }
                );
            }
        },

        isFirstTime: function(state, data) {
            var self = this;
            if (state == 0) { // 本地数据库不需要更新游戏列表
                $.getJSON('../json/QueryGameAll.json', function(data) {
                    self.fillData(data);
                });
            } else { // 本地数据库需要更新游戏列表
                self.fillData(data);
            }
        },

        // 本地数据库的相关操作
        fillData: function(data) {
            var self = this;
            if (window.database) {
                window.database.transaction(function(tx) {
                    tx.executeSql('create table if not exists gameList (id unique, gamename text, gameid text)');
                    tx.executeSql('delete from gameList');
                    var j=0;
                    $.each(data.game_list, function(key, value) {
                        tx.executeSql('insert into gameList (id, gamename, gameid) values(?, ?, ?)', [j+'', value.game_name, value.game_id]);
                        j++;
                    });
//                    app_router.navigate('!listView/1', {trigger: false});
//                    require('./rechargeablecard/listTitle');
//                    require.async('./rechargeablecard/listTitle', function(listView) {
//                        listView.init(8);
//                    });
                    self.reset(data.game_list);
                    require.async('../nav', function(nav) {
                        nav.init(curStep);
                    });
                    $('#loading').fadeOut(200);
                });
            }

        },



        // 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
//            app_router.navigate('!indexCompany', {trigger: false});
        }
    });

    var GameView = Backbone.View.extend({
        el: '#game',

        collection: new Games(),

        initialize: function () {
            var self = this;
            this.collection.on('reset', function() {
                self.render(0);
            });
        },

        template: function(collection) {
            var temp = _.template($('#game_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(state, data) {
            if (state == 0) {
                this.$('.gameList').html(this.template(this.collection.toJSON()));
            } else {
                this.$('.gameList').html(this.template(data));
            }
        },


        events: {
            'tap .gameList li': 'toGameDetail'
        },

        toGameDetail: function(e){
            var obj = $(e.currentTarget);
            window.dT.gameDetail.gameId = obj.attr("alt");
            window.dT.addOrder.gameId = obj.attr("alt");
            window.dT.gameDetail.gameName = obj.text();
            window.dT.leftSource = 1;//返回游戏列表
            app_router.navigate('!gameDetail/4', {trigger: true});
        }

    });


    var gameView = new GameView();
//    var companyView = new GameView();

    return {
        init: function(step) {
            // 初始化相关数据
            curStep = step;
            $('#game .getGame').val('');
            $('#game .list').html('');
            $('#game').show();
            $('.getGame').val("");
            $('#search_g .list').fadeOut(0);
            if(window.dT.gameList.json==''){
                $('#loading').fadeIn(200);
            }
            gameView.collection.fetch();
        }
    };
});