define(function(require) {
    var curStep;
    var tempId;

    var OrderDetail = Backbone.Collection.extend({
        sync: function() {
            var self = this;

            if(isDebug){
                self.isFirstTime(0);
            }

            if(isProxy){
                jfpal.proxyAjax('', {"application": "GC0007",
                        "bizTypeCode": "GC",
                        "merchantId":"0004000018",
                        "param": {method: 'queryUserOrderDesc',
                            clienttype: window.dT.httpData.clienttype,
                            clientversion: window.dT.httpData.clienttype,
                            infversion:window.dT.httpData.infversion,
                            token:window.dT.httpData.token,
                            userid:context.user.id,
                            orderid:window.dT.orderList.orderid
                        }
                    },
                    function(data) {
//                    alert(data);
                        console.log("在这里："+data);
                        if(data.param.data.resstate=="0") {
                            self.isFirstTime(1, data.param.data);
                        }else{
                            if(data.param.data.rescode=="GC99"){
                                alert(window.dT.errorCode.GC99);
                            }
                        }
                    },
                    function(data){
                        alert("queryUserOrderDesc error");
                        $('#loading').fadeOut(200);
                        console.log(data);
                    });
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'queryUserOrderDesc',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token,
                                userid:context.user.id,
                                orderid:window.dT.orderList.orderid
                            }
                        ),
                        dataType:"json",
                        success:function(data){
                            self.isFirstTime(1,data);
                        },
                        error: function (xhr,type) {
                            self.isFirstTime(0);
                        }
                    }
                );
            }


        },

        isFirstTime: function(state, data) {
            var self = this;
            if (state == 0) {
                $.getJSON('../json/OrderDetail.json', function(data) {
                    self.fillData(data);
                });
            } else {
                self.fillData(data);
            }
        },

        // 本地数据库的相关操作
        fillData: function(data) {
            var self = this;
            self.reset(data);
            require.async('../nav', function(nav) {
                nav.init(curStep);
            });
            $('#loading').fadeOut(200);
        },



        // 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
//            app_router.navigate('!indexCompany', {trigger: false});
        }
    });

    var OrderDetailView = Backbone.View.extend({
        el: '#orderDetail',

        collection: new OrderDetail(),

        initialize: function () {
            var self = this;
            this.collection.on('reset', function() {
                self.render(0);
            });
        },

        template: function(collection) {
            _.each(collection, function(value, key) {
//                if(value.order.ptOrderNo.length>11){
//                    value.order.ptOrderNo = value.order.ptOrderNo.substring(0,11);
//                }
                if(value.order.game_name.length>7){
                    value.order.game_name = value.order.game_name.substring(0,7)+"...";
                }
                if(value.order.goods_name.length>7){
                    value.order.goods_name = value.order.goods_name.substring(0,7)+"...";
                }
            });

            var temp = _.template($('#order_detail_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(state, data) {
//            window.dT.orderList.gameName = data.game_name;
            if (state == 0) {
                $('#orderDetail').html(this.template(this.collection.toJSON()));
            } else {
                $('#orderDetail').html(this.template(data));
            }
        },

        events: {
            'tap .submit_btn': 'doPay'
        },

        doPay: function(e){
//            var obj = $(e.currentTarget);
//            $('.cost_form_cost').text(obj.val());
//            console.log(JSON.stringify({
//                "merchantId": "0004000018",
//                "merchantName": '即点卡',
//                "productId": "0000000000",
//                "orderAmt": window.dT.orderDetail.orderAmt,
//                "orderDesc": window.dT.orderDetail.ptorderno,
//                "orderRemark": "aa"
//            }));

            jfpal.jfPay({
                        "merchantId": "0004000018",
                        "merchantName": '即点卡',
                        "productId": "0000000000",
                        "orderAmt": window.dT.orderDetail.orderAmt,
                        "orderDesc": window.dT.orderDetail.ptorderno,
                        "orderRemark": "aa"
                    },
                    function(data){
                        window.dT.orderList.cache = true;
                        app_router.navigate('!indexGame/1', {trigger: true});

//                        alert("123支付成功"+data);

//                        JSON.stringify( data )

                    });
        }
//        doChangeArea: function(e){
//            var obj = $(e.currentTarget);
//            $('.area_text').text(obj.val());
//        }

    });


    var orderDetailView = new OrderDetailView();

    return {
        init: function(step) {
            // 初始化相关数据
            curStep = step;
//            tempId = com_id;
//            $('#gameDetail').html('');
//            require.async('../nav', function(nav) {
//                nav.init(curStep);
//            });
            $('#loading').fadeIn(200);
            orderDetailView.collection.fetch();
        }
    };
});