define(function(require) {
    var curStep;
    var tempId;

    var OrderList = Backbone.Collection.extend({
        sync: function() {
            var self = this;
            if(isDebug){
                self.isFirstTime(0);
            }

            if(isProxy){
                if(window.dT.orderList.json!='' && !window.dT.orderList.cache){
                    self.isFirstTime(1,window.dT.orderList.json);
                }
                jfpal.proxyAjax('', {"application": "GC0006",
                        "bizTypeCode": "GC",
                        "merchantId":"0004000018",
                        "param": {method: 'queryUserOrderList',
                            clienttype: window.dT.httpData.clienttype,
                            clientversion: window.dT.httpData.clienttype,
                            infversion:window.dT.httpData.infversion,
                            token:window.dT.httpData.token,
                            userid:context.user.id}
                    },
                    function(data) {
//                    alert(data);
                        console.log(data);
                        if(data.param.data.resstate=="0") {
                            if(window.dT.orderList.json==''){
                                self.isFirstTime(1,data.param.data);
                                window.dT.orderList.cache = false;
                            }else{
                                if(window.dT.orderList.cache){
                                    self.isFirstTime(1,data.param.data);
                                    window.dT.orderList.cache = false;
                                }else{
                                    $('#loading').fadeOut(200);

                                }
                            }
                            window.dT.orderList.json = data.param.data;
                        }else{
                            if(data.param.data.rescode=="GC99"){
                                alert(window.dT.errorCode.GC99);
                            }
                        }
                    },
                    function(data){
                        alert("queryUserOrderList error");
                        console.log(data);
                        $('#loading').fadeOut(200);
                    });
            }else{
                $.ajax({
                        type:"POST",
                        url:yqUrl,
                        data:JSON.stringify(
                            {method: 'queryUserOrderList',
                                clienttype: window.dT.httpData.clienttype,
                                clientversion: window.dT.httpData.clienttype,
                                infversion:window.dT.httpData.infversion,
                                token:window.dT.httpData.token,
                                userid:context.user.id}
                        ),
                        dataType:"json",
                        success:function(data){
                            self.isFirstTime(1,data);
                        },
                        error: function (xhr,type) {
                            self.isFirstTime(0);
                        }
                    }
                );
            }


        },

        isFirstTime: function(state, data) {
            var self = this;
            if (state == 0) {
                $.getJSON('../json/OrderList.json', function(data) {
                    self.fillData(data);
                });
            } else {
                self.fillData(data);
            }
        },

        // 本地数据库的相关操作
        fillData: function(data) {
            var self = this;
            self.reset(data.orderList);
            require.async('../nav', function(nav) {
                nav.init(curStep);
            });
            $('#loading').fadeOut(200);
        },



        // 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
//            app_router.navigate('!indexCompany', {trigger: false});
        }
    });

    var OrderListView = Backbone.View.extend({
        el: '#orderList',

        collection: new OrderList(),

        initialize: function () {
            var self = this;
            this.collection.on('reset', function() {
                self.render(0);
            });
        },

        template: function(collection) {
//
            _.each(collection, function(value, key) {
                if(value.goods_name.length>7){
                    value.goods_name = value.goods_name.substring(0,7)+"...";
                }
                if(value.game_name.length>7){
                    value.game_name = value.game_name.substring(0,7)+"...";
                }
                value.ptOrderNoTemp = value.ptOrderNo;
//                if(value.ptOrderNo.length>11){
//                    value.ptOrderNo = value.ptOrderNo.substring(0,11);
//                }
            });


            var temp = _.template($('#order_list_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(state, data) {
            if (state == 0) {
//                alert(this.template(this.collection.toJSON()));
                $('#orderList').html(this.template(this.collection.toJSON()));
            } else {
                $('#orderList').html(this.template(data));
            }
        },

        events: {
            'tap #orderList menu ul li': 'orderDetail'
        },

        orderDetail: function(e){
            var obj = $(e.currentTarget);
            window.dT.orderList.orderid = obj.attr("alt");
            window.dT.orderDetail.orderId = obj.attr("alt");
            window.dT.orderDetail.ptorderno = obj.attr("ptordernotemp");
            window.dT.orderSource = 2;
            app_router.navigate('!orderDetail/6', {trigger: true});

        },

        len:function (s) {
        var l = 0;
        var a = s.split("");
        for (var i=0;i<a.length;i++) {
            if (a[i].charCodeAt(0)<299) {
                l++;
            } else {
                l+=2;
            }
        }
        return l;
    }

    });


    var orderListView = new OrderListView();

    return {
        init: function(step) {
            // 初始化相关数据
            curStep = step;
//            tempId = com_id;
//            $('#orderList').html('');
//            require.async('../nav', function(nav) {
//                nav.init(curStep);
//            });
            if(window.dT.orderList.json=='' || window.dT.orderList.cache){
                $('#loading').fadeIn(200);
            }

            orderListView.collection.fetch();
        }
    };
});