/**
 * 添加车辆模块
 */
define(function(require, exports, module) {
       
       var postData = {
       application: 'UpdateCarInfo',
       mobileNo: context.user.mobileNo,
       carId:'',//车id
       shopSign:'',//车牌号
       engineNo:'',//发动机号
       voitureNo:'',//车身号
       cityId:'',//城市ID
       cityName:'',//城市名称
       ownerCar:'',//车主信息
       voitureType:'1'//车辆类型
       };
       
       var ModifyCarModel = Backbone.Model.extend({ });
       
       var ModifyCarView = Backbone.View.extend({
                                                el: '#modifycar',
                                                model: new ModifyCarModel(),
                                                template : _.loadFileTemplate("modifycar"),
                                                events : {
                                                "click .citybtn":"selectcarcity",
                                                "click #framehelpbtn2":"showframehelp",
                                                "click #enginehelpbtn2":"showenginehelp",
                                                "click #modifybtn":"submit",
                                                "click #helpimg2":"hidehelp"
                                                },
                                                initialize: function() {
                                                var self = this;
                                                this.model.on('change', function() {
                                                              self.render();
                                                              });
                                                },
                                                
                                                render: function() {
                                                this.$el.html(this.template({data:this.model.toJSON()}));
                                                },
                                                
                                                selectcarcity:function(){
                                                app_router.navigate('!selectcarcity/2', {trigger: true});
                                                },
                                                
                                                showframehelp:function(event){
                                                
                                                $('#helpimg2').removeClass('fadongji chejia disappear').addClass('chejia');
                                                
                                                },
                                                
                                                showenginehelp:function(event){
                                                
                                                $('#helpimg2').removeClass('fadongji chejia disappear').addClass('fadongji');
                                                
                                                },
                                                hidehelp:function(event){
                                                
                                                $('#helpimg2').addClass('disappear');
                                                
                                                },
                                                
                                                vertify: function() {
                                                
                                                var shopSign = this.$('#carno').val();
                                                
                                                var cityId = this.$('#modifycarcitybtn').attr("cityid");
                                                
                                                var cityName = this.$('#modifycarcitybtn').val();
                                                
                                                var needvoitureNo = this.$('#frameid2').attr("length");
                                                
                                                var voitureNo = this.$('#frameid2').val();
                                                
                                                var needengineNo = this.$('#engineid2').attr("length");
                                                
                                                var engineNo = this.$('#engineid2').val();
                                                
                                                var needownerCar = this.$('#ownername2').attr("isneed");
                                                
                                                var ownerCar = this.$('#ownername2').val();
                                                
                                                var voitureType = this.$('#cartype2').val();
                                                
                                                //校验车牌号
                                                var reg = /^[\u4E00-\u9FA5][a-zA-Z][\da-zA-Z]{5}$/;
                                                
                                                //校验名字是否为中文名
                                                var reg1 = /^[\u4E00-\u9FA5]{1,15}(?:·[\u4E00-\u9FA5]{1,15})*/;
                                                
                                                if (shopSign == '') {
                                                alert('车牌号不能为空', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                if (!reg.test(shopSign)) {
                                                alert('车牌号格式有误，请检查', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                if (cityId == '' || cityName == '') {
                                                alert('查询区域不能为空', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                if(needvoitureNo > 0){
                                                
                                                if (voitureNo == '') {
                                                alert('车身架号不能为空', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                var reg = /[\da-zA-Z]{1,}$/;
                                                if(!reg.test(voitureNo))
                                                {
                                                alert('车身架号格式有误，请检查', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                }
                                                
                                                if(needengineNo > 0){
                                                
                                                if (engineNo == '') {
                                                alert('发动机号不能为空', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                var reg = /[\da-zA-Z]{1,}$/;
                                                if(!reg.test(engineNo))
                                                {
                                                alert('发动机号格式有误，请检查', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                }
                                                
                                                if(needownerCar != 0){
                                                
                                                if (ownerCar == '') {
                                                alert('车主姓名不能为空', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                if (ownerCar.length == 1)
                                                {
                                                alert('车主姓名不能少于两位', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                var pp_name=ownerCar.indexOf("•");
                                                var pe_name=ownerCar.indexOf("·");
                                                
                                                if(pp_name != -1 || pe_name != -1){
                                                if (ownerCar.length > 15)
                                                {
                                                alert('车主姓名不能大于十五位', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                var reg1 = /^[\u4e00-\u9fa5]+[·•][\u4e00-\u9fa5]+$/;
                                                if(!reg1.test(ownerCar))
                                                {
                                                alert('车主姓名格式有误，请检查', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                }else{
                                                if (ownerCar.length > 15)
                                                {
                                                alert('车主姓名不能大于十五位', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                
                                                var reg1 = /^[\u4e00-\u9fa5]+$/;
                                                if(!reg1.test(ownerCar))
                                                {
                                                alert('车主姓名格式有误，请检查', function() {}, '提示', '确定');
                                                return 0;
                                                }
                                                }
                                                
                                                }
                                                
                                                postData.carId = dT.carDetail.detail.carId;
                                                postData.shopSign = shopSign;
                                                postData.cityId = cityId;
                                                postData.cityName = cityName;
                                                postData.voitureNo = voitureNo;
                                                postData.engineNo = engineNo;
                                                postData.ownerCar = ownerCar;
                                                postData.voitureType = voitureType;
                                                
                                                return 1;
                                                },
                                                
                                                submit:function(){
                                                
                                                if (this.vertify() == 1) {
                                                
                                                $('#loading').fadeIn(200);
                                                
//                                                alert(JSON.stringify(postData));
                                                
                                                jfpal.safeAjax('', postData, function(data) {
                                                               
                                                               $('#loading').fadeOut(200, function() {
                                                                                     
                                                                                     app_router.navigate('!index/3', {trigger: true});
                                                                                     
                                                                                     });
                                                               }, function(error) {
                                                               
                                                               $('#loading').fadeOut(200, function() {
                                                                                     alert(error.respDesc, function() {}, '提示', '确定');
                                                                                     });
                                                               });
                                                
                                                }

                                                }
                                                });
       
       var modifyCarView = new ModifyCarView();
       
       return {
       init: function(step) {
       
       modifyCarView.model.set(dT.carDetail.detail);
       
       require.async('../nav', function(nav) {
                     nav.init(1);
                     });
       }
       };
       
       });