/**
 * 选择车辆所在城市模块
 */
define(function(require, exports, module) {
       
       var curStep;
       
       //连接数据库
       var dataBase = openDatabase('carCityList','1.0','支持办理城市列表',1024*1024);
       
       var CarCity = Backbone.Model.extend({
                                           defaults: {
                                           CityCodeName :'',
                                           CityFirstName:'',
                                           CityFullName:'',
                                           CityID:'',
                                           CityName:'',
                                           FullPY:'',
                                           IsHotCity:'',
                                           ProvinceID:'',
                                           ProvinceShortTitle:'',
                                           ShortPY:''
                                           }
                                           });
       
       var CarCitys = Backbone.Collection.extend({
                                                 postData: null,
                                                 sync: function() {
                                                 this.initPostDate(); // 初始化请求参数
                                                 var self = this;
                                                 jfpal.safeAjax('', this.postData, function(data) {
                                                                if (!data.resultBean || data.resultBean.length == 0) {
                                                                self.goBackUrl();
                                                                $('#loading').fadeOut(200, function() {
                                                                                      alert('暂无城市信息', function() {}, '提示', '确定');
                                                                                      });
                                                                } else {
                                                                
                                                                //添加到数据库中
                                                                if(dataBase){
                                                                dataBase.transaction(function(tx) {
                                                                                     tx.executeSql('create table if not exists CityList (id unique, cityid text,cityname text,cityfullname text,shortPY text)');
                                                                                     tx.executeSql('delete from CityList');
                                                                                     var arr = [];
                                                                                     $.each(data.resultBean, function(index, value) {
                                                                                            
                                                                                            tx.executeSql('insert into CityList(id,cityid,cityname,cityfullname,shortPY) values(?,?,?,?,?)'
                                                                                                          ,[index+'',value.CityID,value.CityName,value.CityFullName,value.ShortPY]);
                                                                                            
                                                                                            var carCity = new CarCity({
                                                                                                                      CityCodeName:value.CityCodeName,
                                                                                                                      CityFirstName:value.CityFirstName,
                                                                                                                      CityFullName:value.CityFullName,
                                                                                                                      CityID:value.CityID,
                                                                                                                      CityName:value.CityName,
                                                                                                                      FullPY:value.FullPY,
                                                                                                                      IsHotCity:value.IsHotCity,
                                                                                                                      ProvinceID:value.ProvinceID,
                                                                                                                      ProvinceShortTitle:value.ProvinceShortTitle,
                                                                                                                      ShortPY:value.ShortPY
                                                                                                                      });
                                                                                            
                                                                                            arr.push(carCity);
                                                                                            
                                                                                            });
                                                                                     self.reset(arr);
                                                                                     require.async('../nav', function(nav) {
                                                                                                   nav.init(curStep);
                                                                                                   });
                                                                                     $('#loading').fadeOut(200);
                                                                                     });
                                                                }else{
                                                                alert('数据库创建失败');
                                                                self.goBackUrl();
                                                                }
                                                                
                                                                }
                                                                }, function(error) {
                                                                self.goBackUrl();
                                                                $('#loading').fadeOut(200, function() {
                                                                                      alert(error.respDesc, function() {}, '提示', '确定');
                                                                                      });
                                                                });
                                                 },
                                                 // 初始化safeAjax的数据
                                                 initPostDate: function() {
                                                 this.postData = {
                                                 application: 'SelectCityList',
                                                 mobileNo: context.user.mobileNo,
                                                 deviceNumber: '',
                                                 entranceType: ''
                                                 }
                                                 },
                                                 // 数据请求失败后，改回原来的hash值
                                                 goBackUrl: function() {
                                                 if(curStep == 1){
                                                 app_router.navigate('!addcar/2', {trigger: false});
                                                 }else if(curStep == 2){
                                                 app_router.navigate('!modifycar/2', {trigger: false});
                                                 }
                                                 }
                                                 });
       
       var CarCitysView = Backbone.View.extend({
                                               el: '#selectcarcity',
                                               collection: new CarCitys(),
                                               template : _.loadFileTemplate("selectcarcity"),
                                               events : {
                                               "click .city":"selectcity",
                                               "keyup #searchcarcity":"searchcity"
                                               },
                                               initialize: function() {
                                               var self = this;
                                               this.collection.on('reset', function() {
                                                                  self.render();
                                                                  });
                                               },
                                               render: function() {
                                               this.$el.html(this.template({data: this.collection.toJSON()}));
                                               },
                                               selectcity:function(event){
                                               
                                               var $target = $(event.currentTarget);
                                               
                                               var cityid = $target.attr("cityid");
                                               
                                               var cityname = $target.attr("cityname");
                                               
                                               
                                               $('#loading').fadeIn(200);
                                               
                                               var queryData = {
                                               application: 'SelectViolationSearchRulesList',
                                               mobileNo: context.user.mobileNo,
                                               cityId: cityid,
                                               deviceNumber: '',
                                               entranceType: ''
                                               };
                                               
                                               jfpal.safeAjax('', queryData, function(data) {
                                                              
                                                              var data;
                                                              
                                                              $.each(data.resultBean, function(index, value) {
                                                                     
                                                                     data = value;
                                                                     
                                                                     });
                                                              
                                                              if(data.cityName == null){
                                                              
                                                              $('#loading').fadeOut(200, function() {
                                                                                    alert('该城市暂不支持办理，敬请等待！', function() {}, '提示', '确定');
                                                                                    });
                                                              
                                                              }else{
                                                              
                                                              $('#loading').fadeOut(200, function() {
                                                                                    
                                                                                    if(curStep ==  1){
                                                                                    
                                                                                    $('#content').find('#selectcarcitybtn').attr({"cityid":data.cityId}).val(data.cityName) ;
                                                                                    $('#content').find('#frameid').attr({"length":data.carNoLength});
                                                                                    
                                                                                    if(data.carNoLength > 0){
                                                                                    
                                                                                    $('#content').find('#frameid').attr({"placeholder":"填写完整车架号"});
                                                                                    
                                                                                    }else{
                                                                                    
                                                                                    $('#content').find('#frameid').attr({"placeholder":"可不填"});
                                                                                    
                                                                                    }
                                                                                    
                                                                                    $('#content').find('#engineid').attr({"length":data.engineNoLength});
                                                                                    
                                                                                    if(data.engineNoLength > 0){
                                                                                    
                                                                                    $('#content').find('#engineid').attr({"placeholder":"填写完整发动机号"});
                                                                                    
                                                                                    }else{
                                                                                    
                                                                                    $('#content').find('#engineid').attr({"placeholder":"可不填"});
                                                                                    
                                                                                    }
                                                                                    
                                                                                    $('#content').find('#ownername').attr({"ownername":data.needOwnName});
                                                                                    
                                                                                    app_router.navigate('!addcar/2', {trigger: true});
                                                                                    
                                                                                    }else if(curStep ==  2){
                                                                                    
                                                                                    $('#content').find('#modifycarcitybtn').attr({"cityid":data.cityId}).val(data.cityName) ;
                                                                                    $('#content').find('#frameid2').attr({"length":data.carNoLength});
                                                                                    
                                                                                    if(data.carNoLength > 0){
                                                                                    
                                                                                    $('#content').find('#frameid2').attr({"placeholder":"填写完整车架号"});
                                                                                    
                                                                                    }else{
                                                                                    
                                                                                    $('#content').find('#frameid2').attr({"placeholder":"可不填"});
                                                                                    
                                                                                    }
                                                                                    
                                                                                    $('#content').find('#engineid2').attr({"length":data.engineNoLength});
                                                                                    
                                                                                    if(data.engineNoLength > 0){
                                                                                    
                                                                                    $('#content').find('#engineid2').attr({"placeholder":"填写完整发动机号"});
                                                                                    
                                                                                    }else{
                                                                                    
                                                                                    $('#content').find('#engineid2').attr({"placeholder":"可不填"});
                                                                                    
                                                                                    }
                                                                                    
                                                                                    $('#content').find('#ownername2').attr({"ownername":data.needOwnName});
                                                                                    
                                                                                    app_router.navigate('!modifycar/2', {trigger: true});
                                                                                    
                                                                                    }
                                                                                    
                                                                                    });
                                                              
                                                              }
                                                              
                                                              }, function(error) {
                                                              
                                                              $('#loading').fadeOut(200, function() {
                                                                                    alert(error.respDesc, function() {}, '提示', '确定');
                                                                                    });
                                                              });
                                               
                                               
                                               
                                               },
                                               searchcity:function(){
                                               
                                               var $target = this.$el.find('#searchcarcity');
                                               
                                               var searchkey = $target.val();
                                               
                                               var $list = this.$el.find('.carcitylist');
                                               
                                               $list.empty();
                                               
                                               dataBase.transaction(function(tx) {
                                                                    tx.executeSql("select * from CityList where shortPY like'" + searchkey +"%'", [], function(tx, result) {
                                                                                  var length = result.rows.length;
                                                                                  
                                                                                  if (length != 0) {
                                                                                  for (var i=0; i<length; i++) {
                                                                                  var item = result.rows.item(i);
                                                                                  var str = '<li class="city"' + ' cityid="'+item['cityid']+'" cityname="'+item['cityfullname']+'" >' + item['cityname'] + '</li>';
                                                                                  $list.append(str);
                                                                                  }
                                                                                  }
                                                                                  });
                                                                    });
                                               
                                               }
                                               
                                               });
       
       var carCitysView = new CarCitysView();
       
       return {
       init: function(step) {
       
       curStep = step;
       
       $('#loading').fadeIn(200);
       
       carCitysView.collection.fetch();
       
       }
       };
       
       });