/**
 * 选择邮寄城市模块
 */
define(function(require, exports, module) {
       
       //连接数据库
       var dataBase = openDatabase('postCityList','1.0','支持邮寄城市列表',1024*1024);
       
       var PostCity = Backbone.Model.extend({
                                           defaults: {
                                           CityID :'',
                                           CityName:'',
                                           ProvinceID:'',
                                           ProvinceName:''
                                           }
                                           });
       
       var PostCitys = Backbone.Collection.extend({
                                                 postData: null,
                                                 sync: function() {
                                                 this.initPostDate(); // 初始化请求参数
                                                 var self = this;
                                                 jfpal.safeAjax('', this.postData, function(data) {
                                                                if (!data.resultBean || data.resultBean.length == 0) {
                                                                self.goBackUrl();
                                                                $('#loading').fadeOut(200, function() {
                                                                                      alert('暂无城市信息', function() {}, '提示', '确定');
                                                                                      });
                                                                } else {
                                                                
                                                                //添加到数据库中
                                                                if(dataBase){
                                                                dataBase.transaction(function(tx) {
                                                                                     tx.executeSql('create table if not exists CityList (id unique, cityid text,cityname text,provinceid text,provincename text)');
                                                                                     tx.executeSql('delete from CityList');
                                                                                     var arr = [];
                                                                                     $.each(data.resultBean, function(index, value) {
                                                                                            
                                                                                            tx.executeSql('insert into CityList(id,cityid,cityname,provinceid,provincename) values(?,?,?,?,?)'
                                                                                                          ,[index+'',value.CityID,value.CityName,value.ProvinceID,value.ProvinceName]);
                                                                                            
                                                                                            var postCity = new PostCity({
                                                                                                                      CityID:value.CityID,
                                                                                                                      CityName:value.CityName,
                                                                                                                      ProvinceID:value.ProvinceID,
                                                                                                                      ProvinceName:value.ProvinceName
                                                                                                                      });
                                                                                            
                                                                                            arr.push(postCity);
                                                                                            
                                                                                            });
                                                                                     self.reset(arr);
                                                                                     require.async('../nav', function(nav) {
                                                                                                   nav.init();
                                                                                                   });
                                                                                     $('#loading').fadeOut(200);
                                                                                     });
                                                                }else{
                                                                alert('数据库创建失败');
                                                                self.goBackUrl();
                                                                }
                                                  
                                                                }
                                                                }, function(error) {
                                                                self.goBackUrl();
                                                                $('#loading').fadeOut(200, function() {
                                                                                      alert(error.respDesc, function() {}, '提示', '确定');
                                                                                      });
                                                                });
                                                 },
                                                 // 初始化safeAjax的数据
                                                 initPostDate: function() {
                                                 this.postData = {
                                                 application: 'SelectPostCityList',
                                                 mobileNo: context.user.mobileNo,
                                                 deviceNumber: '',
                                                 entranceType: ''
                                                 }
                                                 },
                                                 // 数据请求失败后，改回原来的hash值
                                                 goBackUrl: function() {
                                                 
                                                 app_router.navigate('!writeorder', {trigger: false});
                                                 
                                                 }
                                                 });
       
       var PostCitysView = Backbone.View.extend({
                                                el: '#selectpostcity',
                                                collection: new PostCitys(),
                                                template : _.loadFileTemplate("selectpostcity"), 
                                                events : {
                                                "click .city":"gotowriteorder",
                                                "change #searchpostcity":"searchcity"
                                                },   
                                                initialize: function() {
                                                 var self = this;
                                                             this.collection.on('reset', function() {
                                                                 self.render();
                                                             });
                                                },
                                                render: function() {
                                                this.$el.html(this.template({data: this.collection.toJSON()}));
                                                },
                                                gotowriteorder:function(event){
                                                
                                                var $target = $(event.currentTarget);
                                                
                                                var cityid = $target.attr("cityid");
                                                
                                                var cityname = $target.attr("cityname");
                                                
                                                $('#content').find('#selectpostcitybtn').attr({"cityid":cityid}).val(cityname) ;
                                                
                                                app_router.navigate('!writeorder/3', {trigger: true});
                                                },
                                                searchcity:function(){
                                                
                                                var $target = this.$el.find('#searchpostcity');
                                                
                                                var searchkey = $target.val();
                                                
                                                var $list = this.$el.find('.postcitylist');
                                                
                                                $list.empty();
                                                
                                                dataBase.transaction(function(tx) {
                                                                     tx.executeSql("select * from CityList where cityname like'" + searchkey +"%'", [], function(tx, result) {
                                                                                   var length = result.rows.length;
                                                                                   
                                                                                   if (length != 0) {
                                                                                   for (var i=0; i<length; i++) {
                                                                                   var item = result.rows.item(i);
                                                                                   var str = '<li class="city"' + ' cityid="'+item['cityid']+'" cityname="'+item['cityname']+'" >' + item['cityname'] + '</li>';
                                                                                   $list.append(str);
                                                                                   }
                                                                                   }
                                                                                   });
                                                                     });
                                                
                                                
                                                }
                                                });
       
       var postCitysView = new PostCitysView();
       
       return {
       init: function() {
       
       $('#loading').fadeIn(200);
       
       postCitysView.collection.fetch();
       
       }
       };
       
       });