/**
 * 生成订单模块
 */
define(function(require, exports, module) {
       
       var curStep;
       var needInvoice = 1;
       var needPenaltyReceipts = 1;
       
       var postData = {
       application: 'SavePeccancyOrder',
       mobileNo: context.user.mobileNo,
       userMobilePhone:'',
       userGender:'false',
       userName:'',
       discountID:'0',
       orderDetailList:'',
       isNeedInvoice:'false',
       isNeedPenaltyReceipts:'false',
       invoiceName:'',
       cityName:'',
       address:'',
       postCode:'',
       receiver:'',
       mobilePhoneNo:'',
       deviceNumber: '',
       entranceType: '',
       channelPoint:''
       };
       
       var CreateOrderModel = Backbone.Model.extend({ });
       
       var CreateOrderModel = Backbone.View.extend({
                                                   el: '#writeorder',
                                                   model: new CreateOrderModel(),
                                                   template : _.loadFileTemplate("writeorder"),
                                                   events : {
                                                   "click .citybtn":"selectpostcity",
                                                   "click #needpostreceipt":"postreceipt",
                                                   "click #needpostinvoice":"postinvoice",
                                                   "click #saveorder":"gotoorderdetail"
                                                   },
                                                   initialize: function() {
                                                   var self = this;
                                                   this.model.on('change', function() {
                                                                 self.render();
                                                                 });
                                                   },
                                                   
                                                   render: function() {
                                                   this.$el.html(this.template({data:this.model.toJSON()}));
                                                   },
                                                   
                                                   selectpostcity:function(){
                                                   
                                                   app_router.navigate('!selectpostcity', {trigger: true});
                                                   
                                                   },
                                                   
                                                   postreceipt: function() {
                                                   
                                                   if(needPenaltyReceipts == 1){
                                                   
                                                   needPenaltyReceipts = 0;
                                                   
                                                   this.$('#needpostreceipt').css({"background-image":"url(./images/unchecked.png)"});
                                                   
                                                   }else if(needPenaltyReceipts == 0){
                                                   
                                                   needPenaltyReceipts = 1;
                                                   
                                                   this.$('#needpostreceipt').css({"background-image":"url(./images/checked.png)"});

                                                   }
                                                   
                                                   },
                                                   
                                                   postinvoice: function() {
                                                   
                                                   if(needInvoice == 1){
                                                   
                                                   needInvoice = 0;
                                                   
                                                   this.$('#needpostinvoice').css({"background-image":"url(./images/unchecked.png)"});
                                                   
                                                   }else if(needInvoice == 0){
                                                   
                                                   needInvoice = 1;
                                                   
                                                   this.$('#needpostinvoice').css({"background-image":"url(./images/checked.png)"});
                                                   
                                                   }
                                                   
                                                   },
                                                   
                                                   vertify: function() {
                                                   
                                                   var isNeedPenaltyReceipts = 'false';
                                                   
                                                   if(needPenaltyReceipts == 1){
                                                   
                                                   isNeedPenaltyReceipts = 'true';
                                                   
                                                   }
                                                   
                                                   var isNeedInvoice = 'false';
                                                   
                                                   if(needInvoice == 1){
                                                   
                                                   isNeedInvoice = 'true';
                                                   
                                                   }
                                                   
                                                   var invoiceName = this.$('#invoicetitle').val();
                                                   
                                                   var userName = this.$('#name').val();
                                                   
                                                   var userGender;
                                                   
                                                   if(this.$("input[name=gender]:checked").val() == '1'){
                                                   
                                                   userGender = 'true';
                                                   
                                                   }else if(this.$("input[name=gender]:checked").val() == '0'){
                                                   
                                                   userGender = 'false';
                                                   
                                                   }
                                                   
                                                   var userMobilePhone = this.$('#phone').val();
                                                   
                                                   var receiver = this.$('#contactname').val();
                                                   
                                                   var mobilePhoneNo = this.$('#contactphone').val();
                                                   
                                                   var cityid = this.$('#selectpostcitybtn').attr("cityid");
                                                   
                                                   var cityName = this.$('#selectpostcitybtn').val();
                                                   
                                                   var address = this.$('#address').val();
                                                   
                                                   var postCode = this.$('#zipcode').val();
                                                
                                                   
                                                   //校验手机号码是否为11位
                                                   var reg2 = /^((13[0-9])|(147)|(15[^4,\D])|(170)|(18[0-9]))\d{8}$/;
                                                   
                                                   //校验邮编是否是数字
                                                   var reg3 = /^[0-9]+$/;
                                                   
                                                   
                                                   if (userName == '') {
                                                   alert('用户姓名不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (userName.length == 1)
                                                   {
                                                   alert('用户姓名不能少于两位', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   var pp_name=userName.indexOf("•");
                                                   var pe_name=userName.indexOf("·");
                                                   
                                                   if(pp_name != -1 || pe_name != -1){
                                                   if (userName.length > 15)
                                                   {
                                                   alert('用户姓名不能大于十五位', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   var reg1 = /^[\u4e00-\u9fa5]+[·•][\u4e00-\u9fa5]+$/;
                                                   if(!reg1.test(userName))
                                                   {
                                                   alert('用户姓名格式有误，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   }else{
                                                   if (userName.length > 15)
                                                   {
                                                   alert('用户姓名不能大于十五位', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   var reg1 = /^[\u4e00-\u9fa5]+$/;
                                                   if(!reg1.test(userName))
                                                   {
                                                   alert('用户姓名格式有误，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   }
                                                   
                                                   if (userMobilePhone == '') {
                                                   alert('用户电话不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (!reg2.test(userMobilePhone)) {
                                                   alert('用户电话格式有误，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if(needInvoice == 1){
                                                   
                                                   if (invoiceName == '') {
                                                   alert('发票抬头不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   }

                                                   
                                                   if(needPenaltyReceipts == 1 ||  needInvoice == 1){
                                                   
                                                   if (receiver == '') {
                                                   alert('联系人姓名不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (receiver.length == 1)
                                                   {
                                                   alert('联系人姓名不能少于两位', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   var pp_name2=receiver.indexOf("•");
                                                   var pe_name2=receiver.indexOf("·");
                                                   
                                                   if(pp_name2 != -1 || pe_name2 != -1){
                                                   if (receiver.length > 15)
                                                   {
                                                   alert('联系人姓名不能大于十五位', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   var reg1 = /^[\u4e00-\u9fa5]+[·•][\u4e00-\u9fa5]+$/;
                                                   if(!reg1.test(receiver))
                                                   {
                                                   alert('联系人姓名格式有误，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   }else{
                                                   if (receiver.length > 15)
                                                   {
                                                   alert('联系人姓名不能大于十五位', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   var reg1 = /^[\u4e00-\u9fa5]+$/;
                                                   if(!reg1.test(receiver))
                                                   {
                                                   alert('联系人姓名格式有误，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   }
                                                   
                                                   if (mobilePhoneNo == '') {
                                                   alert('联系人电话不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (!reg2.test(mobilePhoneNo)) {
                                                   alert('联系人电话格式有误，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (cityid=='' || cityName == '') {
                                                   alert('邮寄城市不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (address == '') {
                                                   alert('邮寄地址不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (postCode == '') {
                                                   alert('邮编不能为空', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (postCode.length != 6) {
                                                   alert('邮编必须是六位数字', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   if (!reg3.test(postCode)) {
                                                   alert('邮编格式不对，请检查', function() {}, '提示', '确定');
                                                   return 0;
                                                   }
                                                   
                                                   }
                                                   
                                                   var areaID = dT.peccancyDetail.detail.AreaID;
                                                   var peccancyTime = dT.peccancyDetail.detail.PeccancyTime;
                                                   var shopSign = dT.peccancyDetail.detail.ShopSign;
                                                   var cityID = dT.peccancyDetail.detail.CityID;
                                                   var regulationID = dT.peccancyDetail.detail.RegulationID;
                                                   
                                                   var orderDetailList = '[{"thirdPoint": "","areaID": "'+areaID+'","islocal": false,"isUrgent": false,"peccancyTime": "'+peccancyTime+'","shopSign": "'+shopSign+'","cityID": "'+cityID+'","regulationID": "'+regulationID+'"}]';
                                                   
                                                   postData.isNeedPenaltyReceipts = isNeedPenaltyReceipts;
                                                   postData.isNeedInvoice = isNeedInvoice;
                                                   postData.invoiceName = invoiceName;
                                                   postData.userName = userName;
                                                   postData.userGender = userGender;
                                                   postData.userMobilePhone = userMobilePhone;
                                                   postData.receiver = receiver;
                                                   postData.mobilePhoneNo = mobilePhoneNo;
                                                   postData.cityName = cityName;
                                                   postData.address = address;
                                                   postData.postCode = postCode;
                                                   postData.orderDetailList = orderDetailList;
                                                   return 1;
                                                   },
                                                   
                                                   gotoorderdetail:function(){
                                                   
//                                                   var orderid = '358989-103528';
//                                                   app_router.navigate('!orderdetail/2/'+orderid, {trigger: true});
                                                   
                                                   if (this.vertify() == 1) {
                                                   
                                                   $('#loading').fadeIn(200);
                                                   
//                                                   alert(JSON.stringify(postData));
                                                   
                                                   jfpal.safeAjax('', postData, function(data) {
                                                                  if (!data.resultBean) {
                                                                  
                                                                  $('#loading').fadeOut(200, function() {
                                                                                        alert('订单生成失败，请稍后再试！', function() {}, '提示', '确定');
                                                                                        });
                                                                  } else {
                                                                  
                                                                  var orderdata;
                                                                  $.each(data.resultBean, function(index, value) {
                                                                         
                                                                         orderdata = value;
                                                                         
                                                                         });
                                                                  
                                                                  if(!orderdata){
                                                                  
                                                                  $('#loading').fadeOut(200, function() {
                                                                                        alert('订单生成失败，请稍后再试！', function() {}, '提示', '确定');
                                                                                        });
                                                                  
                                                                  }else{
                                                                  
                                                                  $('#loading').fadeOut(200, function() {
                                                                                        
                                                                                        var order;
                                                                                        $.each(orderdata.order, function(index, value) {
                                                                                               
                                                                                               order = value;
                                                                                               
                                                                                               });
                                                                                        
                                                                                        var orderid = order.OrderSN;
                                                                                        
                                                                                        app_router.navigate('!orderdetail/2/'+orderid, {trigger: true});
                                                                                        });
                                                                  
                                                                  }
                                                                  }
                                                                  }, function(error) {
                                                                  
                                                                  $('#loading').fadeOut(200, function() {
                                                                                        alert(error.respDesc, function() {}, '提示', '确定');
                                                                                        });
                                                                  });

                                                   }
                                                   }
                                                   });
       
       var createOrderModel = new CreateOrderModel();
       
       return {
       init: function(step) {
       
       curStep = step; // 初始化相关数据
       
       if(curStep == 1){//从违章详情进来
       
       needPenaltyReceipts = 1;
       
       $('#needpostreceipt').css({"background-image":"url(./images/checked.png)"});
       
       needInvoice = 1;
       
       $('#needpostinvoice').css({"background-image":"url(./images/checked.png)"});
       
       $('#invoicetitle').val('');
       
       $('#name').val('');
       
       $('input[name=gender]').each(function(i, v){
                                    if(v.value=='1'){
                                    v.checked = true;
                                    }else{
                                    v.checked = false;
                                    }
                                    });
       
       $('#phone').val('');
       
       $('#contactname').val('');
       
       $('#contactphone').val('');
       
       $('#selectpostcitybtn').attr({"cityid":''}).val('选择城市');
       
       $('#address').val('');
       
       $('#zipcode').val('');
       
       createOrderModel.model.set(dT.peccancyDetail.detail);
       
       }else if(curStep == 2){//返回不做操作
       
       }else if(curStep == 3){//选择城市
       
       }

       require.async('../nav', function(nav) {
                     nav.init(curStep);
                     });
       }
       };
       
       });