//backbone router模块定义
define(function(require, exports, module) {
    //加载导航栏所依赖模块
    require('./config');
    require('./jfpal-config');

    (function() {
      
        if (window.device == undefined){
	    	$('.leftButton').removeClass('hide');
	        $('nav, #content').addClass('android');
	        $('#loading').height($(window).height() - 46); // 设置此页等待层的高度
	        window.pFlag = 'android'; // 平台标志位
        }else if(device.platform == 'Android'){
            $('nav, #content').addClass('android');
            $('#loading').height($(window).height() - 46); // 设置此页等待层的高度
            window.pFlag = 'android'; // 平台标志位
        } else if (device.platform == 'iOS') {
            $('.leftButton').removeClass('hide');
            if (device.version < "7.0") {
                $('nav, #content').addClass('notIOS7');
                $('#loading').height($(window).height() - 46); // 设置此页等待层的高度
            } else {
                $('#loading').height($(window).height() - 66); // 设置此页等待层的高度
            }
            window.pFlag = 'ios'; // 平台标志位
        }


        // 弹出等待层时，禁止滚动
        $(window).on('touchmove', function(e) {
            if ($('#loading').css('display') == 'block') {
                e.preventDefault();
            }
        });
       
       // 替换web的弹框为本地弹框
        if(navigator.notification){
	        window.alert = navigator.notification.alert;
	        window.confirm = navigator.notification.confirm;
        }
        // 创建全局对象dT,方便在各个view之间传递数据
        window.dT = {
            //首页查询航班参数
            queryFlight : {
                depAirport:'',
                depAirportCode:'',
                depCityname:'',
                arrAirport:'',
                arrAirportCode:'',
                arrCityname:'',
                date:''
            },
            
            //登机人信息，联系人信息
            userInfo:{
            	'type':'1',
    			'username':'',
    			'useridno':'',
    			'cusername':'',
    			'cuserphone':'',
    			'cuseremail':''
            }
        };

    })();
    
	_.loadFileTemplate=function(templateName,forceFlush){
		var template;
		$.ajax({
			async:false,
			dataType:'text',
			url:"./js/modules/"+templateName+".html",
			success:function(txt){
				template = _.template(txt);
			},error:function(){
				alert('模版加载错误');
			}
		});
		return template;
	};

    //App Router控制器
    var AppRouter = Backbone.Router.extend({
    	routes: {
    		'': 'index',
            '!index':'index',
            //'!index/:step': 'index', 
            '!choosecity/:step':'choosecity',
            '!flightlist':'flightlist',
            '!flightdetail':'flightdetail',
            '!flightdetail/:step':'flightdetail',
            '!orderconfirm':'orderconfirm',
            '!orderlist/:step':'orderlist',
            '!orderdetail':'orderdetail'
    	},

    	index: function() {
            // alert('index');
    		require.async('./modules/index', function(index) {
                index.init();
    		});
    	},

        choosecity:function(step){
            // alert('choosecity'+step);
            var step = step || '';
            require.async('./modules/choosecity',function(choosecity){
                // alert('choosecity choosecity'+step);
                choosecity.init(step);
            });
        },

        flightlist:function(){
            // alert('flightlist');
            require.async('./modules/flightlist',function(flightlist){
                flightlist.init();
            });
        },

    	flightdetail: function(step) {
    		var step = step || '';
    		require.async('./modules/flightdetail', function(flightdetail) {
                flightdetail.init(step);
    		});
    	},

        orderconfirm:function(){
            require.async('./modules/orderconfirm',function(orderconfirm){
                orderconfirm.init();
            });
        },

    	orderdetail: function() {
    		require.async('./modules/orderdetail', function(orderdetail) {
                orderdetail.init();
    		});
    	},

    	orderlist: function(step) {
    		var step = step || '1';
    		require.async('./modules/orderlist', function(orderlist) {
                orderlist.init(step);
    		});
    	}
    });

    window['app_router'] = new AppRouter;
    Backbone.history.start();
});