define(function(require, exports, module) {
    // 不同的view，触发不同的hash
    var leftHash = '';
    var rightHash = '';

    function goBack() {
        if (leftHash != '') {
            location.hash = leftHash;
        } else {
            context.quit();
        }
        $('#loading').hide(); // 点击返回，隐藏网络请求等待层
    }

    //左侧返回按钮点击事件
    if (typeof device!='undefined' && device.platform == 'iOS') {
        $('nav .leftButton').on('click', goBack);
    } else if (typeof device!='undefined' && device.platform == 'Android') {
        document.addEventListener('backbutton', goBack, false);
    }

    //右侧按钮点击事件
    $('nav .rightButton').on('click', function() {
        location.hash = rightHash;
    });

    //导航条两侧点击效果
    $('.leftButton, .rightButton').on('touchstart', function() {
        $(this).addClass('taped');
    });
    $('.leftButton, .rightButton').on('touchend', function() {
        $(this).removeClass('taped');
    });

    /**
     * 根据业务订单状态码显示订单状态描述信息
     * @param code 订单状态码
     * @param desc 服务端订单描述信息
     * 
     * 客户端显示的订单状态有：待支付，已过期，已支付，出票中，退款中，已退款，已出票,
     * 其他有些状态用服务端的描述信息
     */
    window.orderStateDescByCode = function(code,desc){
    	var statedesc = desc; 
    	switch(code){
    	case "00": //订单生成
    		statedesc = "待支付";
    		break;
    	case "10": //待付款
    		statedesc = "待支付";
    		break;
    	case "20":  //支付成功处理中
    		statedesc = "已支付";
    		break;
    	case "30":  //支付失败处理中
    		break;
    	case "31":  //支付失败
    		statedesc = "待支付";
    		break;
    	case "40":  //付款成功处理中
    		statedesc = "出票中";
    		break;
    	case "50":  //暂不能出票处理中
    		statedesc = "退款中";
    		break;
    	case "60":  //出票失败,退款处理中
    		statedesc = "退款中";
    		break;
    	case "80":   //订单过期
    		statedesc = "已过期";
    		break;
    	case "90":   //机票预定成功
    		statedesc = "已出票";
    		break;
    	case "95":   //已退款
    		statedesc = "已退款";
    		break;
    	case "99":   //订单完成
    		statedesc = "已完成";
    		break;
    	}
    	return statedesc;
    }
    
	C.Config = $.extend(C.Config, {
	    leftBar: function(state) {
	    
            switch (state) {
                case 'index':
                    leftHash = '';
                    break;
                case 'orderlist':
                    leftHash='!index';
                    break;
                case 'orderdetail':
                    leftHash='!orderlist/2';
                    break;
                case 'choosecity':
                    leftHash='!index';
                    break;
                case 'flightlist':
                    leftHash='!index';
                    break;
                case 'flightdetail':
                    leftHash='!flightlist';
                    break;
                case 'orderconfirm':
                    leftHash='!flightdetail/2';
                    break;
            }
	    },

	    rightBar: function(state) {
	    
            switch (state) {
                case 'index':
                    rightHash = '!orderlist/1';
                    $('nav .rightButton').css('visibility', 'visible').text('订单');
                    break;
                case 'orderlist':
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'orderdetail':
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'choosecity':
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'flightlist':
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'flightdetail':
                    $('nav .rightButton').css('visibility', 'hidden');
                    break;
                case 'orderconfirm':
                	$('nav .rightButton').css('visibility', 'hidden');
                    break;
                
            }
	    },

        // 根据相应页面改变导航条                
        setToolBar: function(hash, step, title) {

        	console.log("jfpay-config.setToolBar hash:"+hash+"  \t" +"step:"+step+"  \t"+"title:"+title);
        
            if ((hash == '') || hash.match('index')) {
            
                C.Config.leftBar('index');
                $('nav .navTitle').text('航班查询');
                C.Config.rightBar('index');
                
            } else if (hash.match('flightlist')) {
            
                C.Config.leftBar('flightlist');
                var title = title||'航班列表';
                $('nav .navTitle').text(title);
                C.Config.rightBar('flightlist');
                
            } else if (hash.match('flightdetail')) {

            	C.Config.leftBar('flightdetail');
            	$('nav .navTitle').text('航班详情');
            	C.Config.rightBar('flightdetail');
                
            } else if (hash.match('orderconfirm')) {
            
                C.Config.leftBar('orderconfirm');
                $('nav .navTitle').text('确认订单');
                C.Config.rightBar('orderconfirm');
                
            } else if (hash.match('orderlist')) {
            
                C.Config.leftBar('orderlist');
                $('nav .navTitle').text('我的订单');
                C.Config.rightBar('orderlist');
                
            } else if (hash.match('orderdetail')) {
            
                C.Config.leftBar('orderdetail');
                $('nav .navTitle').text('订单详情');
                C.Config.rightBar('orderdetail');
                
            } else if(hash.match('choosecity')){
                C.Config.leftBar('choosecity');
                $('nav .navTitle').text('选择城市');
                C.Config.rightBar('choosecity');
                
            }
        }
	});

});