/**
* 选择城市机场模块
*/
define(function(require,exports,module){
	
	var curStep;

	//连接数据库
	var dataBase = openDatabase('airportList','1.0','机场列表',1024*1024);

	var Cities = Backbone.Collection.extend({
		sync:function(){
			this.fillData();
			$('#loading').fadeOut(200);
		},

		// 数据请求失败后，改回原来的hash值
        goBackUrl: function() {
            app_router.navigate('!index', {trigger: false});
        },

		//将aiport.json数据填充到web sql
		fillData:function(){
			$.getJSON('./airport.json',function(data){
				//添加到数据库中
				if(dataBase){
					dataBase.transaction(function(tx) {
						tx.executeSql('create table if not exists airportList (id unique, cityname text,code text,engname text,airportname text)');
                   		tx.executeSql('delete from airportList');
                    	var j=0,hotCity={};
                    	$.each(data,function(){
                    		if(this.key == '热门'){
                    			hotCity = this.list;
                    			return;
                    		}
                    		for(var i=0;i<this.list.length;i++){
                    			j+=1;
                    			var airport = this.list[i];
                    			tx.executeSql('insert into airportList(id,cityname,code,engname,airportname) values(?,?,?,?,?)'
                    				,[j+'',airport.cityName,airport.threeCode,airport.engName,airport.airportName]);
                    		}
                    	});

                    	chooseCityView.render(data);
						require.async('../nav',function(nav){
							nav.init(curStep);
						});
					});
				}else{
					alert('数据库创建失败',function() {}, '提示', '确定');
					self.goBackUrl();
				}
			});
		}
		
	});

	var ChooseCityView = Backbone.View.extend({
		el:'#choosecity',
		collection:new Cities(), 
		template:_.loadFileTemplate('choosecity'),

		events:{
			// "click #city1-btn":'choosecity'
			'input .getCity': 'selected', // 注意,当input框里面是中文时,input事件触发两次,只能是不完美解决办法
            'click .list li': 'toIndex',
            'click .cityList li': 'toIndex'
		},

		initialize:function(){
			// this.$el.html(this.template());
		},

		 selected: function() {
            var self = this;
            // 下拉联想
            if ($('.getCity').val() == '') {
                $('.list').hide();
                self.$('.cityList').show();
                return;
            }
            var val = $('.getCity').val();
            this.$('.list').empty();

            dataBase.transaction(function(tx) {
                tx.executeSql("select * from airportList where cityname like'" + val +"%'", [], function(tx, result) {
                    var length = result.rows.length;
                    $('.list').empty();
                    if (length != 0) {
                        for (var i=0; i<length; i++) {
                        	var item = result.rows.item(i);
                            var str = '<li' + ' data-code="'+item['code']+'" data-name="'+item['airportname']+'" >' + item['cityname'] + '</li>';
                            $('.list').append(str);
                        }
                        $('.list').show();
                        self.$('.cityList').hide();
                    } else {
                        $('.list').hide();
                        self.$('.cityList').show();
                    }
                });
            });  
        },
                                       
        toIndex: function(e) {
            var $obj = $(e.currentTarget);
            if (!$obj.hasClass('first')) {
                var code = $obj.attr('data-code');
                var airportname = $obj.attr('data-name');
                airportname = airportname.replace('机场','');
                var cityname = $obj.text();
                // alert('code:'+code+"\nairportname:"+airportname+"\ncityname:"+cityname);
               	if(curStep == 1){
               		dT.queryFlight.depAirport = airportname;
					dT.queryFlight.depCityname = cityname;
					dT.queryFlight.depAirportCode = code;
               	}else if(curStep == 2){
					dT.queryFlight.arrAirport= airportname;
					dT.queryFlight.arrAirportCode = code;
					dT.queryFlight.arrCityname = cityname;
               	}
                app_router.navigate('!index', {trigger: true});
            }
        },

		citylist_template:function(data){
			var temp = '';
			$.each(data,function(){
				var key = this.key;
				var value = this.list;
				var length = value.length;
				if(length == 0){
					return;
				}
				var isFL = '';
				var str = '';
				for(var i=0;i<=length;i++){
					if(i==0){
						isFL = ' class="first" ';
					}else if(i == length){
						isFL = ' class="last" ';
					}else{
						isFL = '';
					}
					var text = (i == 0)?key:value[i-1]['cityName'];
					if(i == 0){
						str += '<li' + isFL + '>' + text + '</li>';
					}else{
						str += '<li' + isFL + ' data-code="'+value[i-1]['threeCode']+'" data-name="'+value[i-1]['airportName']+'" >' + text + '</li>';
					}
					

				}
				// str = '<ul>' + str + '</ul>';
				temp +=str;
			});
			// alert(temp);
			return temp;
		},

		render:function(data){
			// this.$('.cityList').empty();
			this.$el.html(this.template());
			this.$('.cityList').html(this.citylist_template(data));
		}
	});

	var chooseCityView = new ChooseCityView();

	return{
		init:function(step){
			curStep = step;
			$('#loading').fadeIn(200);
			// alert(curStep);

			chooseCityView.collection.fetch();

			// require.async('../nav',function(nav){
			// 	nav.init(step);
			// });
		}
	};
});