/**
* 航班详情
*/
define(function(require,exports,module){
	var wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2 ];
	var vi = [ 1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2 ];
	var ai = new Array(18);

	function verify(idcard) {
		if (idcard.length == 15) {
			idcard = convert(idcard);
		}
		if (idcard.length != 18) {
			return false;
		}
		var verify = idcard.substring(17, 18);
		if (verify == getverify(idcard)) {
			return true;
		}
		return false;
	};

	function getverify(eighteencard) {
		var mod = 0;
		if (eighteencard.length == 18) {
			eighteencard = eighteencard.substring(0, 17);
			var sum = 0;
			for (var i = 0; i < 17; i++) {
				var k = eighteencard.substring(i, i + 1);
				ai[i] = k;
			}
			for (var j = 0; j < 17; j++) {
				sum += wi[j] * ai[j];
			}
			mod = sum % 11;
		}
		return (mod == 2) ? "X" : vi[mod];
	};

	function convert(fifteencard) {
		var eighteencard = fifteencard.substring(0, 6);
		eighteencard += "19";
		eighteencard += fifteencard.substring(6, 15);
		eighteencard += getverify(eighteencard);
		return eighteencard;
	};
	
	var FlightDetail = Backbone.Model.extend({
		data:null,
		
		sync:function(){
			$('#loading').fadeIn(200);
			var postData = new Object();
			var flight = dT.flight;
			postData.application = 'TK0002';
			postData.bizTypeCode = 'TK';
			postData.merchantId="0004000013";
			postData.param = new Object();
			postData.param.orgCity = flight.cstar;
			postData.param.dstCity = flight.cdest;
			postData.param.airCompany="";   //可为空
			postData.param.startDateTime="";//可为空
			var tstar = flight.tstar.split(' ');
			var tstardate = tstar[0];
			postData.param.startDate=tstardate;//起飞日期
			var avContent = "";
			avContent += flight.flight.substring(0,2);
			avContent +=',';
			avContent +=flight.flight;
			avContent +=',';
			avContent +=flight.cstar;
			avContent +=',';
			avContent +=flight.cdest;
			avContent +=',';
			avContent +=flight.tstar;
			avContent +=',';
			avContent +=flight.tdest;
			avContent +=',';
			var seats = flight.f_az.split('');
			var first = true;
			var patrn = /^[1-9A]$/;  //有位置
			for(var i=0;i<seats.length;i++){
				var seat = seats[i];
				if(patrn.exec(seat)){
					var code = String.fromCharCode(0x41+i);
					if(code == 'F'|| code =='C' || code == 'A' || code =='D'){
						//头等舱代码一般为F、A ；公务舱为C、D
						continue;
					}
					if(first){
						first=false;
					}else{
						avContent += '-';
					}
					avContent +=code;
					avContent +='_';
					avContent += seat;
				}
			}
			postData.param.avContent = avContent;
//			alert(JSON.stringify(postData));
			//请求接口
			var self = this;
			jfpal.proxyAjax('',postData,function(data){
				console.log(JSON.stringify(data));
				if(data.respCode == '0000'){
					self.data = data.param.data;
					self.fillData();
					$('#loading').fadeOut(200);
				}else{
					//self.handleFail(data.respDesc);
					self.handleFail("查询运价失败,请稍后重试");
				}
			},function(error){
				console.log(error);
				self.handleFail("查询运价失败,请稍后重试");
//				self.handleFail('无法连接到服务器，请稍后重试');
			});
		},
		
		handleFail:function(msg){
			this.goBackUrl();
            $('#loading').fadeOut(200,function(){
            	alert(msg,function() {}, '提示', '确定');
            });
		},
		
		// 数据请求失败后，改回原来的hash值
		goBackUrl : function() {
			app_router.navigate('!flightlist', {
				trigger : false
			});
		},

		fillData : function() {
			require.async('../nav',function(nav){
				nav.init();
				flightdetailView.initUserInfo();
				flightdetailView.render();
				$('body').scrollTop(0);
			});

		}
	});
	
	var FlightDetailView = Backbone.View.extend({
		el:'#flightdetail',
		model:new FlightDetail(),
		template:_.loadFileTemplate('flightdetail'),
		events:{
			"click #J_orderConfirm":'confirmInfo',
			"click #J_storeOrder":'doCheckStoreOrder',
			"click .flight-wright":"showRules",
			"click #J_flightdetail_rules":"hideRules",
			"click .form-item label.name":"showNameRules",
			"click #J_flightdetail_namerules":"hideNameRules",
			"click #flightdetail .form-item label.idno":"showTypeDialog",
			"click #flightdetail #J_fd_bg":"hideTypeDialog",
			"click #flightdetail .cui-select-view li":"selectType"
		},

		initialize:function(){
//			self.initUserInfo();
		},
		
		initUserInfo:function(){
			var userInfo = localStorage.getItem('flight_usrinfo');
//			console.log("flightDetail initialize:"+userInfo);
			if(userInfo != null){
				userInfo = $.parseJSON(userInfo);
				dT.userInfo = userInfo;
			}else{
				dT.userInfo = {
	            	'type':'1',
	    			'username':'',
	    			'useridno':'',
	    			'cusername':'',
	    			'cuserphone':'',
	    			'cuseremail':''
	            };
			}
//			console.log("flightDetail dT.userInfo:"+JSON.stringify(dT.userInfo));
		},
		
		//选中或取消选中保存登机人信息
		doCheckStoreOrder:function(){
			var $chxStoreOrder = $("#J_storeOrder");
			if($chxStoreOrder.hasClass('on')){
				$chxStoreOrder.removeClass('on');
			}else{
				$chxStoreOrder.addClass('on');
			}
		},
		
		showTypeDialog:function(){
			$("#J_fd_bg").css('visibility','visible');
			$("#J_fd_type").css('visibility','visible');
		},
		
		hideTypeDialog:function(){
			$("#J_fd_bg").css({'visibility':'hidden'});
			$("#J_fd_type").css({'visibility':'hidden'});
		},
		
		selectType:function(e){
			this.hideTypeDialog();
			$("#flightdetail .cui-select-view li").removeClass("current");
			var $obj = $(e.currentTarget);
			$obj.addClass('current');
			var index = $obj.attr('data-index');
			if(index == 1){
				$('#flightdetail .form-item label.idno').text('身份证');
			}else{
				$('#flightdetail .form-item label.idno').text('护照');
			}
			$("#J_idno").val('');
		},
		
		render:function(){
			//封装数据
			var data = this.model.data;
			if(data.flight.boardPointAT != ''){
				data.depairport = data.flight.boardPointAT;
			}else{
				data.depairport = dT.queryFlight.depAirport+'机场';
			}
			if(data.flight.offPointAT != ''){
				data.arrairport = data.flight.offPointAT;
			}else{
				data.arrairport = dT.queryFlight.arrAirport+'机场';
			}
			data.tstartime = dT.flight.tstarTime;
			data.tdesttime = dT.flight.tdestTime;
//			data.airline = dT.flight.airline.replace('中国','').replace('集团','');
			data.airline = data.bdrss.acshortname;
			data.flightNo = dT.flight.flight;
			data.fmodel = dT.flight.fmodel;
			if('1' == dT.flight.fmeals){
				data.fmeals= '有餐饮';
			}else{
				data.fmeals = '无餐饮';
			}
			if(data.flight1.code == "F"){
				data.cabintype = '头等舱';
			}else if(data.flight1.code == "C"){
				data.cabintype = '商务舱';
			}else{
				data.cabintype = '经济舱';
			}
			var price = data.flight1.f.replace('.00','');
			data.price = price;
			var discount = data.flight1.r/10;
			data.discount =discount;
			var jiyou = Number(data.flight.buildFee)+Number(data.flight.oilFee);
			data.jiyou = jiyou;
			data.total = data.flight1.s.replace('.00','');
			
			this.$el.html(this.template(data));
			this.showUserInfo();
			
			if (window.device == undefined || device.platform == 'Android') {
				if (!$('.fd-wrapper').hasClass('android')) {
					$('.fd-wrapper').addClass('android');
				}
			} else if (device.platform == 'iOS') {
				if (device.version < "7.0") {
					if (!$('.fd-wrapper').hasClass('notIOS7')) {
						$('.fd-wrapper').addClass('notIOS7');
					}
				}
			}
		},

		//检查输入参数是否合法
		checkInput:function(){
			var type = $("#flightdetail .cui-select-view li.current").attr('data-index');
			var username = $.trim($("#J_name").val());
			var useridno = $.trim($("#J_idno").val().toUpperCase());
			var cusername = $.trim($("#J_contactPerson").val());
			var cuserphone =$.trim($('#J_contactPhone').val());
			var cuseremail =$.trim($('#J_contactMail').val());
			if(this.checkNotEmpty('证件名称',username,1)
					&& this.checkNotEmpty('证件号码',useridno,1)
					&& this.checkNotEmpty('联系人姓名',cusername,1)
					&& this.checkNotEmpty('手机号',cuserphone,1)){
				if(!this.checkName(username,"证件姓名")){
					return false;
				}
				if(!this.checkName(cusername,"联系人姓名")){
					return false;
				}
				if(!this.checkPhone(cuserphone)){
					alert('请输入合法的11位手机号',function() {}, '提示', '确定');
					return false;
				}
				if(type == 1){
					if(!this.checkIdcardNo(useridno)){
						alert('请输入合法的身份证号',function() {}, '提示', '确定');
						return false;
					}
				}else{
					if(!this.checkPassport(useridno)){
						alert('请输入合法的护照号',function() {}, '提示', '确定');
						return false;
					}
				}
				if(this.checkNotEmpty('联系邮箱',cuseremail,0) && !this.checkEmail(cuseremail)){
					alert('请输入合法的邮箱地址',function() {}, '提示', '确定');
					return false;
				}
			}else{
				return false;
			}
			dT.userInfo.type = type;
			dT.userInfo.username = username;
			dT.userInfo.useridno = useridno;
			dT.userInfo.cusername = cusername;
			dT.userInfo.cuserphone = cuserphone;
			dT.userInfo.cuseremail =cuseremail;
			return true;
		},
		
		//检查姓名
		checkName:function(name,label){
			if(name.length < 2){
				alert(label+"不能少于2位",function() {}, '提示', '确定');
				return false;
			}
			if(name.length >15){
				alert(label+"不能多于15位",function() {}, '提示', '确定');
				return false;
			}
			var patrn = /^(([\u4e00-\u9fa5]+[·•]{0,1}[\u4e00-\u9fa5]+)|([a-zA-Z]+(\s)*[a-zA-Z]+))$/;
			if(!patrn.exec(name)){
				alert('请输入合法的'+label,function() {}, '提示', '确定');
				return false;
			}else{
				return true;
			}
		},
		
		//检查手机格式
		checkPhone:function(phone){
			var patrn = /^((13[0-9])|(147)|(15[^4,\D])|(170)|(18[0-9]))\d{8}$/;
			if(!patrn.exec(phone)){
				return false;
			}else{
				return true;
			}
		},
		
		//检查邮箱格式
		checkEmail:function(email){
			var patrn = /^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
			if(!patrn.exec(email)){
				return false;
			}else{
				return true;
			}
		},
		
		//检查身份证号
		checkIdcardNo:function(idno){
			return verify(idno);
		},
		
		//检查护照号
		checkPassport:function(idno){
			var patrn = /^[a-zA-Z0-9]+$/;
			if(!patrn.exec(idno)){
				return false;
			}else{
				return true;
			}
		},
		
		checkNotEmpty:function(name,value,salert){
			if(value == ''){
				if(salert == 1){
					alert(name+'不能为空',function() {}, '提示', '确定');
				}
				return false;
			}else{
				return true;
			}
		},
		
		//保持登机人信息、联系人信息
		saveUserInfo:function(){
			if($("#J_storeOrder").hasClass('on')){
				//保存联系人到localstorage
				var jsonUserInfo = JSON.stringify(dT.userInfo);
				localStorage.setItem('flight_usrinfo',jsonUserInfo);
			}else{
				localStorage.removeItem('flight_usrinfo');
			}
		},
		
		//显示登机人信息
		showUserInfo:function(){
			$('#J_name').val(dT.userInfo.username);
			$('#J_idno').val(dT.userInfo.useridno);
			$('#J_contactPerson').val(dT.userInfo.cusername);
			$('#J_contactPhone').val(dT.userInfo.cuserphone);
			$('#J_contactMail').val(dT.userInfo.cuseremail);
			if(dT.userInfo.type == 1){
				$("#flightdetail .form-item label.idno").text('身份证');
			}else{
				$('#flightdetail .form-item label.idno').text('护照');
			}
			$("#flightdetail .cui-select-view li").removeClass("current");
			var $obj = $("#flightdetail .cui-select-view li");
			$.each($obj,function(index,item){
				$item = $(item);
				if(dT.userInfo.type == $item.attr('data-index')){
					$item.addClass('current');
				}
			});
		},
		
		confirmInfo:function(){
			if(this.checkInput()){
				this.saveUserInfo();
				dT.flightDetail = this.model.data;
				app_router.navigate('!orderconfirm',{trigger:true});
			}
		},
		
		//隐藏退改签规则
		hideRules:function(){
			$("#J_flightdetail_rules").hide();
		},
		
		//显示退改签规则
		showRules:function(){
			$("#J_flightdetail_rules").show();
		},
		
		//显示证件名字规则
		showNameRules:function(){
			$("#J_flightdetail_namerules").show();
		},
		
		//隐藏证件名字规则
		hideNameRules:function(){
			$("#J_flightdetail_namerules").hide();
		}
	});

	var flightdetailView = new FlightDetailView();

	return{
		init:function(step){
			if(step == 2){
				//从后面页面返回时不刷新页面
				require.async('../nav',function(nav){
					nav.init();
				});
			}else{
				flightdetailView.model.fetch();
			}
		}
	};
});