/**
 * 航班列表
 */
define(function(require, exports, module) {
	var flagFirst; 
	var queryFlight;
	var queryDate;
	var queryParams = {};
	
	var Flights = Backbone.Collection.extend({
		dataList:null,
		
		sync : function() {
			var self = this;
			$('#loading').fadeIn(200);
			var postData = new Object();
			postData.application = 'TK0001';
			postData.bizTypeCode = 'TK';
			postData.merchantId="0004000013";
			postData.param = new Object();
			postData.param.T1=queryFlight.depAirportCode;
			postData.param.T2=queryFlight.arrAirportCode;
			postData.param.D1=queryDate;
//			alert(JSON.stringify(postData));
			//请求接口    并过滤没有座位的航班
			jfpal.proxyAjax('', postData, function(data) {
				console.log(JSON.stringify(data));
				if(data.respCode == '0000'){
					var mdataList = data.param.data;
					self.dataList = new Array();
					if(mdataList != null && mdataList.length > 0){
						for(var i=0;i<mdataList.length;i++){
							var data = mdataList[i];
							if(self.hasSeat(data)){
								self.dataList.push(data);
							}
						}
					}
					flightlistView.render();
					$('body').scrollTop(0);
					if(self.dataList.length == 0){
						self.handleNoData();
					}else{
						$('#loading').fadeOut(200);
					}
				}else{
//					self.handleFail(data.respDesc);
					self.handleFail("查询航班失败,请稍后重试");
				}
            }, 
	        function(data){
            	console.log(data);
            	self.handleFail("查询航班失败,请稍后重试");
//            	self.handleFail('无法连接到服务器，请稍后重试');
	        }); 
		},

		handleNoData:function(){
			$('#loading').fadeOut(200,function(){
            	alert('暂无航班',function() {}, '提示', '确定');
            });
		},
		
		handleFail:function(msg){
			if(flagFirst == 1){
				this.goBackUrl();
        	}
            $('#loading').fadeOut(200,function(){
            	alert(msg,function() {}, '提示', '确定');
            });
		},
		
		// 数据请求失败后，改回原来的hash值
		goBackUrl : function() {
			app_router.navigate('!index', {
				trigger : true
			});
		},
		
		//经济舱是否有座位
		hasSeat:function(flight){
			var seats = flight.f_az.split('');
			var patrn = /^[1-9A]$/;  //有位置
			for(var i=0;i<seats.length;i++){
				var seat = seats[i];
				if(patrn.exec(seat)){
					var code = String.fromCharCode(0x41+i);
					if(code == 'F'|| code =='C' || code == 'A' || code =='D'){
						//头等舱代码一般为F、A ；公务舱为C、D
						continue;
					}
					return true;
				}
			}
			return false;
		},

	});

	var FlightListView = Backbone.View.extend({
		el : '#flightlist',
		template : _.loadFileTemplate('flightlist'),
		lstItemTmlp:_.loadFileTemplate('flightlist_item'),
		collection : new Flights(),
		now : new Date(),

		events : {
			"click .flight-list li" : 'toDetail',
			'click .prev' : 'backOneDay',
			'click .next' : 'goOneDay'
		},

		initialize : function() {
			
		},
		
		render : function() {
			this.$el.html(this.template());
			var $lstContainer = $("#J_FlightListWrap");
			var length = 5;
			var dataList = this.collection.dataList;
			var data;
			for(var i= 0;i<dataList.length;i++){
				data = dataList[i];
				data.index = i;
				data.depAirport = queryFlight.depAirport+'机场';
				data.arrAirport = queryFlight.arrAirport+'机场';
				var airline = data.airline.replace('中国','').replace('集团','');
				data.airline = airline;
				var tdest = data.tdest.split(' ');
				var tdestdate = tdest[0];
				var tstar = data.tstar.split(' ');
				var tstardate = tstar[0];
				if(tdestdate == tstardate){
					data.istomorrow = "";
				}else{
					data.istomorrow = "+1天";
				}
				data.tstartime = data.tstarTime;
				data.tdesttime = data.tdestTime;
				
				lstitem =this.lstItemTmlp(data);
				$lstContainer.append(lstitem);
			}
			
			$('.nowDate').text(queryDate);
			if (window.device == undefined || device.platform == 'Android') {
				if (!$('.top-bar').hasClass('android')) {
					$('.top-bar').addClass('android');
				}
			} else if (device.platform == 'iOS') {
				if (device.version < "7.0") {
					if (!$('.top-bar').hasClass('notIOS7')) {
						$('.top-bar').addClass('notIOS7');
					}
				}
			}
		},

		isBeforeToday : function(compareDate) {
			if (compareDate < this.now) {
				alert('无法查询早于今日的航班', function() {
				}, '提示', '确定');
				return false;
			} else {
				return true;
			}
		},

		backOneDay : function() {
			var sDate = new Date(this.$('.nowDate').text());
			if (this.isBeforeToday(sDate)) {
				sDate.setDate(sDate.getDate() - 1);
				var date = this.formateDatePicker(sDate);
				this.queryList(date);
			}
		},

		// 格式化通过 DatePicker 返回的时间数据
		formateDatePicker : function(date) {
			var sYear = date.getFullYear(), sMonth = (date.getMonth() + 1), sDate = date
					.getDate();
			sMonth = (sMonth < 10) ? ('0' + sMonth) : sMonth;
			sDate = (sDate < 10) ? ('0' + sDate) : sDate;
			var showDate = sYear + '-' + sMonth + '-' + sDate;
			// var showDate = sMonth + '月' + sDate+'日';
			return showDate;
		},

		goOneDay : function() {
			var sDate = new Date(this.$('.nowDate').text());
			sDate.setDate(sDate.getDate() + 1);
			var date = this.formateDatePicker(sDate);
			this.queryList(date);
		},

		queryList:function(date){
			flagFirst = 2;
			queryDate = date;
			this.collection.fetch();
		},
		
		toDetail : function(e) {
			var $obj = $(e.currentTarget);
			var index = $obj.attr('data-index');
			var data = this.collection.dataList[index];
			dT.flight = data;
//			alert(JSON.stringify(data));
//			return false;
			app_router.navigate('!flightdetail', {
				trigger : true
			});
		}
	});

	var flightlistView = new FlightListView();

	return {
		init : function() {
			flagFirst = 1;
			queryFlight = dT.queryFlight;
			queryDate = queryFlight.date;
			flightlistView.$el.html("");
			var title = '';
			if (queryFlight.depAirport != '') {
				title = queryFlight.depAirport + '-'+ queryFlight.arrAirport
			}
			require.async('../nav', function(nav) {
				nav.init(1, title);
				flightlistView.collection.fetch();
			});
		}
	};
});