/**
* 首页航班查询模块
*/
define(function(require,exports,module){
	var pFlag = this.pFlag; //平台标志位

	var IndexView = Backbone.View.extend({
		el:'#index',
		template:_.loadFileTemplate('index'),

		events : {
			"click #J_SearchSubmitBtn":"query",
			"click #J_depCity":"chooseDepCity",
			"click #J_dep":"chooseDepCity",
			"click #J_arrCity":"chooseArrCity",
			"click #J_arr":"chooseArrCity",
			"click .input-for-date":"chooseDate",
			"click .J_swap":"switchCity",
			"change input[type=date]":"dateChanged"
		},

		initialize:function(){
			// this.render();
			this.setDefault();
		},

		setDefault:function(){
			var queryFlight = localStorage.getItem('queryFlight');
			queryFlight = $.parseJSON(queryFlight);
			if(queryFlight == null){
				dT.queryFlight.depAirport = "上海虹桥";
				dT.queryFlight.depCityname = "上海";
				dT.queryFlight.depAirportCode = "SHA";
				dT.queryFlight.arrAirport= "北京首都";
				dT.queryFlight.arrAirportCode = "PEK";
				dT.queryFlight.arrCityname = "北京";
				dT.queryFlight.date = this.initDepDate();
			}else{
				dT.queryFlight.depAirport = queryFlight.depAirport;
				dT.queryFlight.depCityname = queryFlight.depCityname;
				dT.queryFlight.depAirportCode = queryFlight.depAirportCode;
				dT.queryFlight.arrAirport= queryFlight.arrAirport;
				dT.queryFlight.arrAirportCode = queryFlight.arrAirportCode;
				dT.queryFlight.arrCityname = queryFlight.arrCityname;
				dT.queryFlight.date = this.initDepDate();
			}
		},
		
		saveHistory:function(){
			var jsonFlight = JSON.stringify(dT.queryFlight);
			localStorage.setItem("queryFlight",jsonFlight);
		},
		
		render:function(){
			this.$el.html(this.template());
			if(pFlag == 'android'){
				$('#J_DatePicker').removeClass('js_hide');
				$('#J_DatePicker2').addClass('js_hide');
			}else{
				$('#J_DatePicker2').removeClass('js_hide');
				$('#J_DatePicker').addClass('js_hide');
			}
			this.update();
		},

		//更新界面参数
		update:function(){
			// alert(dT.queryFlight.date+"  date");
			if(pFlag =='android'){
				$('#J_DatePicker').text(dT.queryFlight.date);
			}else{
				$('#J_DatePicker2').val(dT.queryFlight.date);
			}
			$depCity =$("#J_depCity");
			$arrCity =$("#J_arrCity");
			// $depCity.text(dT.queryFlight.depAirport);
			$depCity.text(dT.queryFlight.depCityname);
			$depCity.attr('data-code',dT.queryFlight.depAirportCode);
			$depCity.attr('data-cityname',dT.queryFlight.depCityname);
			// $arrCity.text(dT.queryFlight.arrAirport);
			$arrCity.text(dT.queryFlight.arrCityname);
			$arrCity.attr('data-code',dT.queryFlight.arrAirportCode);
			$arrCity.attr('data-cityname',dT.queryFlight.arrCityname);
		},

		//切换城市
		switchCity:function(){
			var depAirport = dT.queryFlight.depAirport;
			var depAirportCode = dT.queryFlight.depAirportCode;
			var depCityname = dT.queryFlight.depCityname;
			var arrAirport = dT.queryFlight.arrAirport;
			var arrAirportCode=dT.queryFlight.arrAirportCode;
			var arrCityname = dT.queryFlight.arrCityname;
			dT.queryFlight.depAirport = arrAirport;
			dT.queryFlight.depCityname = arrCityname;
			dT.queryFlight.depAirportCode = arrAirportCode;
			dT.queryFlight.arrAirport= depAirport;
			dT.queryFlight.arrAirportCode = depAirportCode;
			dT.queryFlight.arrCityname = depCityname;
			this.update();
		},

		//查询
		query:function(){
			if(dT.queryFlight.depAirportCode == dT.queryFlight.arrAirportCode){
				alert("出发和到达不能为同一城市",function(){}, '提示', '确定');
				return;
			}
			if(dT.queryFlight.date == ''){
				dT.queryFlight.date = this.initDepDate();
				this.update();
			}
			this.saveHistory();
			app_router.navigate('!flightlist',{trigger:true});
		},

		//选择出发城市
		chooseDepCity:function(){
			// alert('chooseDepCity');
			app_router.navigate('!choosecity/1',{trigger:true})
		},

		//选择目的地城市
		chooseArrCity:function(){
			// alert('chooseArrCity');
			app_router.navigate('!choosecity/2',{trigger:true})
		},

		// 初始化出发日期为明天
        initDepDate: function() {
            var tomorrow = new Date();
            tomorrow.setDate(tomorrow.getDate() + 1);
            var sYear = tomorrow.getFullYear(),
                sMonth = (tomorrow.getMonth() + 1),
                sDate = tomorrow.getDate();
            sMonth = (sMonth < 10) ? ('0' + sMonth) : sMonth;
            sDate = (sDate < 10) ? ('0' + sDate) : sDate;                       
            var currentDate = sYear + '-' + sMonth + '-' + sDate;
            // var currentDate = sMonth + '月' + sDate+'日';
            return currentDate;
        },

		// 格式化通过 DatePicker 返回的时间数据
        formateDatePicker: function(date) {
            var sYear = date.getFullYear(),
                sMonth = (date.getMonth() + 1),
                sDate = date.getDate();
            sMonth = (sMonth < 10) ? ('0' + sMonth) : sMonth;
            sDate = (sDate < 10) ? ('0' + sDate) : sDate;
            var showDate = sYear + '-' + sMonth + '-' + sDate;
            // var showDate = sMonth + '月' + sDate+'日';
            return showDate;
        },

		//选择日期
		chooseDate:function(){
			if(pFlag == 'android'){
				var self = this;
				var options = {
					date:new Date(),
					mode:'date'
				};
				datePicker.show(options,function(date){
					if(date != 'Invalid Date'){
						var date = new Date(date);
						dT.queryFlight.date = self.formateDatePicker(date);
						self.update();
					}
				});
			}
		},
		
		dateChanged:function(){
			dT.queryFlight.date = $('#J_DatePicker2').val();
			console.log('dateChanged:'+dT.queryFlight.date);
		}
        
        
	});

	var indexView = new IndexView();

	return{
		init:function(){
			require.async('../nav',function(nav){
				nav.init();
				indexView.render();
			});
		}
	};
});