/**
*订单确认
*/
define(function(require,exports,module){
	
	var OrderConfirm = Backbone.Model.extend({
		sync:function(){
			var postData = new Object();
			postData.application = 'TK0003';
			postData.bizTypeCode = 'TK';
			postData.merchantId="0004000013";
			postData.param = new Object();
			postData.param.userMobile = context.user.mobileNo;
			//政策信息
			postData.param.policyParams = new Object();
			postData.param.policyParams.policyid = dT.flightDetail.flight1.policy.id;
			postData.param.policyParams.disc = dT.flightDetail.flight1.policy.disc;
			//航班信息
			postData.param.flightParams = new Object();
			postData.param.flightParams.takeOffDate = dT.flightDetail.flight.departureDate;
			postData.param.flightParams.takeOffTime = dT.flightDetail.flight.departureTime;
			postData.param.flightParams.arriveTime = dT.flightDetail.flight.arrivalTime;
			postData.param.flightParams.arrivedate = dT.flightDetail.flight.arrivalDate;
			postData.param.flightParams.ibePrice = dT.flightDetail.flight1.f;
			postData.param.flightParams.buildFee = dT.flightDetail.flight.buildFee;
			postData.param.flightParams.oilFee = dT.flightDetail.flight.oilFee;
			postData.param.flightParams.cabin = dT.flightDetail.flight1.code;
			postData.param.flightParams.flightNo = dT.flight.flight;
			postData.param.flightParams.acfamily = dT.flight.fmodel;
			postData.param.flightParams.arrvairportcode = dT.flightDetail.flight.offPoint;
			postData.param.flightParams.deptairportcode = dT.flightDetail.flight.boardPoint;
			postData.param.flightParams.arrterm = dT.flightDetail.flight.offPointAT;
			postData.param.flightParams.depterm = dT.flightDetail.flight.boardPointAT;
			postData.param.flightParams.arrcityname = dT.queryFlight.arrCityname;
			postData.param.flightParams.depcityname = dT.queryFlight.depCityname;
			postData.param.flightParams.contactname = dT.userInfo.cusername;  // 联系人姓名
			postData.param.flightParams.contactmobile = dT.userInfo.cuserphone;
			//购票人信息
			postData.param.passengerParams = new Object();
			postData.param.passengerParams.paxfoidtp = dT.userInfo.type;
			postData.param.passengerParams.paxfoidid = dT.userInfo.useridno;
			postData.param.passengerParams.paxmobile = dT.userInfo.cuserphone;
			postData.param.passengerParams.paxmaile = dT.userInfo.cuseremail;
			postData.param.passengerParams.paxname = dT.userInfo.username;   //登机人姓名
			postData.param.passengerParams.paxtype = '1'; //1成人
			console.log(JSON.stringify(postData));
			$('#loading').fadeIn(200);
			var self = this;
			$('#orderconfirm .ft').hide();
			jfpal.proxyAjax('',postData,function(data){
				console.log(JSON.stringify(data));
				if(data.respCode == '0000'){
					var data = data.param.data;
					console.log(JSON.stringify(data));
					console.log('需支付:'+Number(dT.flightDetail.total)*100+'分');
					//支付订单
					var payData = {
							"merchantId": "0004000013",
	                        "merchantName": '即机票',
	                        "productId": '0000000000',
	                        "orderAmt": Number(dT.flightDetail.total)*100 +"",   //支付金额 单位分
	                        "orderDesc": data.order.outid,     //一般为业务订单号
	                        "orderRemark": ""	               //一般为业务订单补充信息
					};
					console.log(JSON.stringify(payData));
					$('#loading').fadeOut(200);
					dT.orderid = data.order.outid;
					dT.needRefreshOl = true;  //生成订单后至订单详情页再返回到订单列表时刷新订单列表
					jfpal.jfPay(payData,
                        function(data){
							console.log("jfpal success:"+JSON.stringify(data));
        					app_router.navigate('!orderdetail',{trigger:true});
                        },function(error){
                        	console.log("jfpal fail:"+JSON.stringify(error));
                            alert("支付失败,请在半小时内完成订单支付",function() {}, '提示', '确定');
        					app_router.navigate('!orderdetail',{trigger:true});
                        });
				}else{
//					self.handleFail(data.respDesc);
					self.handleFail("创建订单失败，请稍后重试");
				}
			},function(error){
				console.log(error);
				$('#orderconfirm .ft').show();
				self.handleFail("创建订单失败，请稍后重试");
//				self.handleFail('无法连接到服务器，请稍后重试');
			});
		},
		
		handleFail:function(msg){
            $('#loading').fadeOut(200,function(){
            	alert(msg,function() {}, '提示', '确定');
            });
		},
	});
	
	var OrderConfirmView = Backbone.View.extend({
		el:'#orderconfirm',
		template:_.loadFileTemplate('orderconfirm'),
		model:new OrderConfirm(),
		events:{
			"click #J_orderSubmit":'createOrderAndPay',
			"click #orderconfirm .flight-wright":"showRules",
			"click #J_oc_rules":"hideRules"
		},

		initialize:function(){
//			this.render();
		},

		render:function(){
			var data = dT.flightDetail;
			this.$el.html(this.template(data));
			//绑定信息
//			console.log("oc userInfo"+JSON.stringify(dT.userInfo));
			$('#J_oc_name').text(dT.userInfo.username);
			$('#J_oc_idno').text(dT.userInfo.useridno);
			if(dT.userInfo.type == 1){
				$('#orderconfirm .idno').text('身份证');
			}else{
				$('#orderconfirm .idno').text('护照');
			}
			$('#J_oc_contactPerson').text(dT.userInfo.cusername);
			$('#J_oc_contactPhone').text(dT.userInfo.cuserphone);
			if($.trim(dT.userInfo.cuseremail) == ''){
				$('#J_oc_contactMail').text('未填写');
			}else{
				$('#J_oc_contactMail').text(dT.userInfo.cuseremail);
			}
		},

		//隐藏退改签规则
		hideRules:function(){
			$("#J_oc_rules").hide();
		},
		
		//显示退改签规则
		showRules:function(){
			$("#J_oc_rules").show();
		},
		
		createOrderAndPay:function(){
			this.model.fetch();
		}
	});

	var orderconfirmView = new OrderConfirmView();

	return{
		init:function(){
			require.async('../nav',function(nav){
				nav.init();
				orderconfirmView.render();
			});
		}
	};
});