/**
*订单详情
*/
define(function(require,exports,module){
	
	var OrderDetail = Backbone.Model.extend({
		data:null,
		
		sync:function(){
			$('#loading').fadeIn(200);
			var postData = new Object();
			postData.application = 'TK0005';
			postData.bizTypeCode = 'TK';
			postData.merchantId="0004000013";
			postData.param = new Object();
			postData.param.orderId = dT.orderid;
			console.log(JSON.stringify(postData));
			
			var self = this;
			jfpal.proxyAjax('',postData,function(data){
				console.log(JSON.stringify(data));
				if(data.respCode == '0000'){
					self.data = data.param.data;
					$('#loading').fadeOut(200);
					orderdetailView.render();
				}else{
//					self.handleFail(data.respDesc);
					self.handleFail('查询详情失败，请稍后重试');
				}
			},function(error){
				console.log(error);
				self.handleFail('查询详情失败，请稍后重试');
//				self.handleFail('无法连接到服务器，请稍后重试');
			});
		},
		
		handleFail:function(msg){
			var self = this;
			this.goBackUrl();
            $('#loading').fadeOut(200,function(){
            	alert(msg,function() {}, '提示', '确定');
            });
		},
		
		// 数据请求失败后，改回原来的hash值
		goBackUrl : function() {
			app_router.navigate('!orderlist/2', {
				trigger : true
			});
		}
	});
	
	var OrderDetailView = Backbone.View.extend({
		el:'#orderdetail',
		template:_.loadFileTemplate('orderdetail'),
		model:new OrderDetail(),
	
		events:{
			"click #J_od_pay":'pay',
			"click .jstgq":"toggleRules"
		},

		initialize:function(){
		},

		render:function(){
			var data = this.model.data;
			if(data.detail.depterm != ''){
				data.detail.depairport = data.detail.depterm;
			}else{
				data.detail.depairport = data.detail.deptairportcodename;
			}
			if(data.detail.arrterm != ''){
				data.detail.arrairport = data.detail.arrterm;
			}else{
				data.detail.arrairport = data.detail.arrvairportcodename;
			}
			var user = data.users[0];
			if(user.paxfoidtp ==1){
				user.paxtypename = '身份证';
			}else if(user.paxfoidtp == 2){
				user.paxtypename = '护照';
			}
			data.detail.ibeprice = data.detail.ibeprice.replace('.00','');
			data.detail.oilfee = data.detail.oilfee.replace('.00','');
			data.detail.buildfee = data.detail.buildfee.replace('.00','');
			data.detail.airlinename = data.detail.airlinename.replace('中国','').replace('集团','');
			data.order.statedesc = orderStateDescByCode(data.order.state,data.order.statedesc);
			
			this.$el.html(this.template(data));
			
			if(data.order.serialid == ''){
				$('#odorderpno').css('display','none');
				$('#odorderpno2').css('display','none');
			}
			if(data.detail.ticketnumber == ''){
				$('#odordertno').css('display','none');
				$('#odordertno2').css('display','none');
			}
			if(data.order.state != '10' || data.order.state =='31'){
				$('#J_od_pay').css('display','none');
			}
			if(data.users[0].paxmaile == ''){
				$('#odmail').css('display','none');
				$('#odmail2').css('display','none');
			}
			if(data.remoteOrder.success == true){
				var orderstate = data.remoteOrder.data.order.orderstatus;
				if(orderstate == '逾期订单' 
					&& (data.order.state == '10'|| data.order.state == '31'))
				{
					var self = this;
					dT.needRefreshOl = true;
					alert("订单已关闭",function(){
					}, '提示', '确定');
				}
			}
		},

		pay:function(){
			var data = this.model.data;
			var orderstate = data.remoteOrder.data.order.orderstatus;
			console.log("remote orderstate:"+orderstate);
			if(orderstate == '待支付'){
				//订单支付
				console.log('需支付:'+Number(data.detail.payprice)*100+'分');
//				$('#loading').fadeIn(200);
//				//支付订单
				var payData = {
						"merchantId": "0004000013",
                        "merchantName": '即机票',
                        "productId": '0000000000',
                        "orderAmt": Number(data.detail.payprice)*100 +"",   //支付金额 单位分
                        "orderDesc": data.order.orderid,     //一般为业务订单号
                        "orderRemark": ""	               //一般为业务订单补充信息
				};
				console.log(JSON.stringify(payData));
				//调用native支付
				jfpal.jfPay(payData,
                    function(data){
						console.log("jfpal success:"+JSON.stringify(data));
						dT.needRefreshOl = true;
    					app_router.navigate('!orderlist/2',{trigger:true});
                    },function(error){
                    	console.log("jfpal fail:"+JSON.stringify(error));
                    });
			}else if(orderstate == '逾期订单'){
				alert("订单已关闭",function() {}, '提示', '确定');
			}
		},
		
		toggleRules:function(){
			if($(".flight-pnttips").hasClass('js_hide')){
				$(".flight-pnttips").removeClass('js_hide');
				$(".jstgq").removeClass('flight-arrdown');
				$(".jstgq").addClass("flight-arrup");
			}else{
				$(".flight-pnttips").addClass('js_hide');
				$(".jstgq").addClass('flight-arrdown');
				$(".jstgq").removeClass("flight-arrup");
			}
		}
	});

	var orderdetailView = new OrderDetailView();

	return{
		init:function(){
			orderdetailView.$el.html("");
			require.async('../nav',function(nav){
				nav.init();
				orderdetailView.model.fetch();
			});
		}
	};
});