/**
* 订单列表
*/
define(function(require,exports,module){
	var isClickPay = false;
	var flagFirst;   //标记是不是第一次请求接口，1为第一次请求，2为分页请求
	
	var OrderList = Backbone.Collection.extend({
		dataList:null,
		currpage:0,
		totalcount:0,
		size:10,
		reqPage:1,
		
		hasNextPage:function(){
			if(this.currpage*this.size >= this.totalcount){
				return false;
			}else{
				return true;
			}
		},
		
		init:function(){
			this.currpage=0;
			this.totalcount=0;
			this.size=10;
			this.reqPage=1;
			this.dataList = new Array();
		},
		
		sync:function(){
			$('#loading').fadeIn(200);
			var self = this;
			//请求接口
			var postData = new Object();
			postData.application = 'TK0004';
			postData.bizTypeCode = 'TK';
			postData.merchantId="0004000013";
			postData.param = new Object();
			postData.param.mobile = context.user.mobileNo;
			postData.param.page = self.reqPage+"";
			postData.param.size = self.size+"";
			console.log(JSON.stringify(postData));
			
			jfpal.proxyAjax('', postData, function(data) {
				console.log(JSON.stringify(data));
				if(data.respCode == '0000'){
					var mdataList = data.param.data.orders;
					self.totalcount = data.param.data.count;
					self.currpage = data.param.data.page;
					if(self.currpage == 1){
						self.dataList = new Array();
					}
					if(mdataList != null && mdataList.length > 0){
						console.log("orderlist reqpage："+self.reqPage+"   "+mdataList.length+'条数据');
						for(var i=0;i<mdataList.length;i++){
							self.dataList.push(mdataList[i]);
						}
					}
					orderlistView.render();
					console.log("orderlist:"+self.dataList.length+'条数据');
					if(self.dataList.length == 0){
						self.handleNoData();
					}else{
						$('#loading').fadeOut(200);
					}
				}else{
					//self.handleFail(data.respDesc);
					self.handleFail('查询航班列表失败，请稍后重试');
				}
            }, 
	        function(data){
            	console.log(data);
            	self.handleFail('查询航班列表失败，请稍后重试');
//            	self.handleFail('无法连接到服务器，请稍后重试');
	        }); 
		},
		
		// 数据请求失败后，改回原来的hash值
		goBackUrl : function() {
			app_router.navigate('!index', {
				trigger : true
			});
		},
		
		handleNoData:function(){
			var self = this;
			$('#loading').fadeOut(200,function(){
            	alert('暂无订单',self.goBackUrl(), '提示', '确定');
            });
		},
		
		handleFail:function(msg){
			if(flagFirst == 1){
				this.goBackUrl();
        	}
            $('#loading').fadeOut(200,function(){
            	alert(msg,function() {}, '提示', '确定');
            });
		}
	});
	
	var OrderListView = Backbone.View.extend({
		el:'#orderlist',
		template:_.loadFileTemplate('orderlist'),
		lstItemTmpl:_.loadFileTemplate('orderlist_item'),
		collection:new OrderList(),
		
		events:{
			"click .olist-item-btn":"toPay",
			"click .J_orderItem":'orderDetail',
			"click .olist-main .more":'loadMore'
		},

		initialize:function(){
//			this.render();
		},

		render:function(){
			this.$el.html(this.template());
			
			var $listContainer = $('.J_listBox');
			var dataList = this.collection.dataList;
			var data,lstItem;
			for(var i=0;i<dataList.length;i++){
				data = dataList[i];
				data.index = i;
				if(data.detail.depterm != ''){
					data.detail.depairport = data.detail.depterm;
				}else{
					data.detail.depairport = data.detail.deptairportcodename;
				}
				if(data.detail.arrterm != ''){
					data.detail.arrairport = data.detail.arrterm;
				}else{
					data.detail.arrairport = data.detail.arrvairportcodename;
				}
				data.detail.airlinename = data.detail.airlinename.replace('中国','').replace('集团','');
				data.order.statedesc = orderStateDescByCode(data.order.state,data.order.statedesc);
				if(data.order.state == '10' || data.order.state == '31'){
					data.order.statebtn = '去付款';
				}else{
					data.order.statebtn = '查看详情';
				}
				lstItem = this.lstItemTmpl(data);
				$listContainer.append(lstItem);
			}
			
			if(this.collection.hasNextPage()){
				$('.olist-main .more').css('display','block');
			}else{
				$('.olist-main .more').css('display','none');
			}
		},

		loadMore:function(){
			flagFirst = 2;
			this.collection.reqPage = this.collection.currpage+1;
			this.collection.fetch();
		},
		
		orderDetail:function(e){
			if(isClickPay){
				isClickPay = false;
				return false;
			}
			var $obj = $(e.currentTarget);
			var index = $obj.attr('data-index');
			dT.orderid = this.collection.dataList[index].order.orderid;
//			alert($obj.attr('data-index'));
			app_router.navigate('!orderdetail',{trigger:true});
		},
		
		toPay:function(e){
			var $obj= $(e.currentTarget);
			var index = $obj.attr('data-index');
			var state = $obj.attr('data-state');
			if(state == '10' || state == '31'){
				//订单有可能已过期，需要服务端在详情接口去查询机票方的接口才知道订单是否有效，所有在列表页不直接去支付
				//这边支付暂时不做，直接让事件穿透后自动触发orderDetail函数
//				isClickPay = true;
//				alert('to pay index:'+index+'  state:'+state);
			}else{
				//事件穿透后自动触发orderDetail函数
			}
			return false;
		}
	});

	var orderlistView = new OrderListView();
	
	return{
		init:function(step){
			var step = step;
			if(step == '2' && !dT.needRefreshOl){
				//从订单详情页返回，且不需要更新
				require.async('../nav', function(nav) {
					nav.init();
				});
			}else{
				dT.needRefreshOl = false;
				flagFirst = 1;
				orderlistView.collection.init();
				orderlistView.$el.html("");
				require.async('../nav', function(nav) {
					nav.init();
					orderlistView.collection.fetch();
				});
			}
		}
	};
});