//backbone router模块定义
define(function(require, exports, module) {
    //加载导航栏所依赖模块
    require('./config');
    require('./jfpal-config');
    window.datanum={
        marketname:"",
        shopList: {application: 'GetShopName'}
    };

    (function() {
        if (device.platform == 'Android') {
            $('nav, #trolley_layer, #steps').addClass('android');
            $('#loading').addClass('android').height($('body').height() - 46);
        } else if (device.platform == 'iOS') {
            $('.leftButton').removeClass('hide');
            if (device.version < "7.0") {
                $('nav, #trolley_layer, #steps').addClass('notIOS7');
                $('#loading').addClass('notIOS7').height($('body').height() - 46);
            } else {
                $('#loading').height($('body').height() - 66);
            }
        }

        // 替换web的弹框为本地弹框
        window.alert = navigator.notification.alert;
        window.confirm = navigator.notification.confirm;
        
        new FastClick(document.body); // 消除click事件在触摸UI上的点击延迟
    }());

    //App Router控制器
    var AppRouter = Backbone.Router.extend({
    	routes: {
    		'': 'findWeidian',
            '!orders/:step': 'orders',
            '!order_detail/:step': 'showOrderDetail',
            '!findWeidian/:step': 'findWeidian',
            '!enterWeidian/:step': 'enterWeidian',
    		'!settlement/:step': 'settlement',
            '!newaddress/:step': 'newaddress',
            '!addaddress/:step':'addaddress',
            '!newproduct/:step': 'newproduct',
            '!addproduct/:step':'addproduct',
            '!searchproduct/:step':'searchproduct'
    	},

    	findWeidian: function(step) {
    		// require.async('./nav', function(nav) {
                // step = step || '';
    		// 	nav.init(step);
    		// });

    		require.async('./visitWeidian/findWeidian', function(findWeidian) {
                 step = step || '';
                 findWeidian.init(step);
    		});
    	},

        orders: function(step) {
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/orders', function(orders) {
                 step = step || '';
                 orders.init(step);
            });
        },
        showOrderDetail: function(step) {
            require.async('./visitWeidian/orderDetails', function(orderDetail) {
                 orderDetail.init(step);
            });  
        },

        enterWeidian: function(step) {
            // require.async('./nav', function(nav) {
            //     nav.init(step);
            // });

            require.async('./visitWeidian/enterWeidian', function(enterWeidian) {
                 enterWeidian.init(step);
            });
        },

        settlement: function(step) {
            require.async('./nav', function(nav) {
                nav.init(step);
            });

            require.async('./visitWeidian/settlement', function(settlement) {
                 settlement.init(step);
            });
        },
        newaddress:function(step){
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/newaddress', function(newaddress) {
                 newaddress.init(step);
            });
        },
        addaddress:function(step){
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/addaddress', function(addaddress) {
                 addaddress.init(step);
            });
        },
        newproduct:function(step){
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/newproduct', function(newproduct) {
                 newproduct.init(step);
            });
        },
        addproduct:function(step){
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/addproduct', function(addproduct) {
                 addproduct.init(step);
            });
        },
        searchproduct: function() {
            require.async('./nav', function(nav) {
                nav.init(step);
            });
            require.async('./visitWeidian/searchproduct', function(searchproduct) {
                 searchproduct.init(step);
            });
        }

    });

    window['app_router'] = new AppRouter;
    Backbone.history.start();
});