define(function(require,exports,module){
	var curStep=0;
	var apiUrl = require('../apiConfig');
    var addressInfo;

	var AddressUpdater = Backbone.Collection.extend({
        url: apiUrl.addr + '?r=customer.address.create',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'post',
                data: {
                    name: $(".input[name='name']").val(),
                    tel: $(".input[name='tel']").val(),
                    province: $("select[name='province']").val(),
                    address: $("textarea[name='address']").val(),
                    city: ""
                },
                success: function(data) {
                    if (data.success) {
                        addressInfo = data.address;
                        window.selectedAddress = addressInfo;
                        $('#loading').fadeOut(200, function() {
                            alert("添加地址成功", function() {
                                $("#form_addaddress").get(0).reset();
                            	self.goBackUrl();
                            }, '提示', '确定');
                        });
                    } else {
                        $('#loading').fadeOut(200, function(e) {
	                        alert(data.msg || '请检查当前网络', function() {}, '提示', '确定');
	                    });
                    }
                },
                error: function() {
                    $('#loading').fadeOut(200, function(e) {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        goBackUrl: function(address_id) {
            app_router.navigate('!newaddress/' + address_id, {trigger: true});
        }
    });

	var AddAddressView = Backbone.View.extend({
		el: '#addaddress',

		collection: new AddressUpdater(),

		initialize: function() {
            var self = this;
            this.collection.on('reset', this.render, this);

            this.$el.isHappy({
                    submitButton: '#submitAddress',
                    fields: {
                        // reference the field you're talking about, probably by `id`
                        // but you could certainly do $('[name=name]') as well.
                        '#address_name': {
                            required: true,
                            message: '请填入收件人姓名'
                        },
                        '#address_tel': {
                            required: true,
                            message: '请填入正确的收件人联系手机号',
                            test: happy.mobile
                        },
                        '#address_province': {
                            required: true,
                            message: '请填入收件人所在省'
                        },
                        '#address_address': {
                            required: true,
                            message: '请填入收件人详细地址'
                        }
                    }
            });
        },

        events: {
            'click a.save_btn': 'save_address'
        },

        save_address: function(e) {
            var obj = $(e.currentTarget);
            this.collection.fetch();
        },

        render: function() {
        	var provinces = "上海市,江苏省,浙江省,江西省,天津市,安徽省,河南省,四川省,湖南省,福建省,广西省,海南省,广东省,甘肃省,重庆市,贵州省,云南省,宁夏,陕西省,山西省,湖北省,河北省,山东省,内蒙古,北京市,吉林省,辽宁省,黑龙江省,西藏,新疆,青海省".split(",");
			var provinces_select = $("select[name='province']");
			provinces_select.empty();
			provinces_select.append( "<option value=''>请选择省份</option>");
			for (var i = provinces.length - 1; i >= 0; i--) {
				provinces_select.prepend( "<option value='"+provinces[i]+"'>"+provinces[i]+"</option>");
			}

            
        }
	})

	var addAddress = new AddAddressView();

	return{
		init:function(step){
			addAddress.render();
		}
	}
});