define(function(require,exports,module){

	var apiUrl = require('../apiConfig');
	var curStep = 0;
	var ntText = "新增地址";
	var addresses = [];

	var AddressList = Backbone.Collection.extend({
        url: apiUrl.addr + '?r=customer.address.list',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    mobile_no: sessionStorage.mobile_no
                },
                success: function(data) {
                    if (data.success) {
                        addresses = data.addresses;
                        self.reset(data.addresses);
                        //显示页面
                        require.async('../nav', function(nav) {
                            nav.init(1, ntText);
                        });
                        $('#loading').fadeOut(200);
                    } else {
                        self.goBackUrl();
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    self.goBackUrl();
                    $('#loading').fadeOut(200, function() {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        goBackUrl: function() {
            switch (curStep) {
                case '1':
                    app_router.navigate('!findWeidian', {trigger: false});
                    break;
            }
        }
    });

	var NewAddressView=Backbone.View.extend({
		el:'#newaddress',

		events:{
			'tap .add':'add',
			'tap .right_delete':'addressDelete',
			'tap .addresslist li': 'addressSelect',
			'swipeLeft .addresslist li': 'showDelete',
			'longTap .addresslist li  > div': 'showDeleteHack'
		},

		collection: new AddressList(),

		initialize: function() {
            var self = this;
            this.collection.on('reset', function() {
                self.render();
            });
            this.render();
                                            
                                            
        },

		add:function(){
			app_router.navigate('!addaddress/0',{trigger:true});
		},

		showDelete: function(e) {
            var obj = $(e.currentTarget);
            obj.find('.modify, .delete').addClass('moveLeft');
        },

        showDeleteHack: function(e) {
        	var self = this;
            confirm('', function(index) {
                if (index == 1) {
                    self.confirm_delete(e, 2);
                }
            }, '请选择', ['删除联系人']);
        },

        addressSelect: function(e) {
        	var obj = $(e.currentTarget);
        	if ($(e.target).hasClass('right_delete')) {
        		return;
        	};
        	$(".active_mark").removeClass("active");
            obj.find(".active_mark").addClass("active");
            this.setGlobalAddress(obj.data('id'));
        },

        setGlobalAddress: function(addressId) {
            window.selectedAddress = null;
            if (addressId == null) {
                return;
            }
            for (var i = addresses.length - 1; i >= 0; i--) {
                if(addressId == addresses[i].id) {
                    window.selectedAddress = addresses[i];
                }
            }
        },

        addressDelete: function(e) {
        	var self = this;
        	var obj = $(e.currentTarget);
                                            var addressId = obj.parents("li").data("id");
                                            obj.parents("li").hide();
        	if (addressId == null) {
        		return;
        	}
            $.ajax({
                url: apiUrl.addr + '?r=customer.address.remove',
                type: 'post',
                data: {
                    "address_id": addressId
                },
                success: function(data) {
                    if (data.success) {
                        if (window.selectedAddress && window.selectedAddress.id == addressId) {
                            self.setGlobalAddress(null);
                        };
                        newAddress.collection.fetch();
                        $('#loading').fadeOut(200);
                    } else {
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {
                            	newAddress.collection.fetch();
                            }, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    $('#loading').fadeOut(200, function() {
                        alert(data.msg || '请检查当前网络', function() {
                        	newAddress.collection.fetch();
                        }, '提示', '确定');
                    });
                }
            });
        },

		template: function(data) {
            var temp = _.template($('#address_tpl').html(), {collection: data, selectedAddress: window.selectedAddress});
            return temp;
        },

		render: function(state) {
            this.$('.addresslist').html(this.template(this.collection.toJSON()));
        },

		chose:function(e){
			
		},

	});

	var newAddress = new NewAddressView();

	return {
		init:function(address_id){
			selectedSelected = address_id;
			newAddress.collection.fetch();
		}
	}
});

