define(function(require,exports,module){

	var apiUrl = require('../apiConfig');
    var visitWeidian = require('./enterWeidian');
	var curStep = 1;
	var ntText = "添加商品";
	var productes = [];

    var ProductList = Backbone.Collection.extend({
        url: apiUrl.addr + '?r=store.product.list',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    mobile_no: sessionStorage.mobile_no
                },
                success: function(data) {
                    if (data.success) {
                        pl = data.product_list;
                        self.reset(data.product_list);
                        //显示页面
                        require.async('../nav', function(nav) {
                            nav.init(curStep, ntText);
                        });
                        $('#loading').fadeOut(200);
                    } else {
                        self.goBackUrl();
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    self.goBackUrl();
                    $('#loading').fadeOut(200, function() {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        goBackUrl: function() {
            switch (curStep) {
                case '1':
                    app_router.navigate('!enterWeidian/1', {trigger: false});
            }
        }
    });

	var NewProductView=Backbone.View.extend({
		el:'#newproduct',

		events:{
			'tap .productlist li': 'productSelect',
			'swipeLeft .productlist li': 'showDelete',
            'tap .sear': 'dataTransfer',
		},

		collection: new ProductList(),

		initialize: function() {
            var self = this;
            this.collection.on('reset', function() {
                self.render();
            });
            this.render();                     
        },

        
        toSearchList: function() {
            var keyword = this.$('input.menu_ele').val();
            if (keyword == '') {
                alert('请输入商品关键字', function() {}, '提示');
            } 
            else {
                // sessionStorage.flagshipId = context.appuser;
                sessionStorage.keyword = keyword;
                app_router.navigate('!searchproduct/1', {trigger: true});
            }
        },

        productSelect: function(e) {
            var obj = $(e.currentTarget);
            var goods_name = "商品",
                price = obj.children('.price').text(),
                image_src = obj.children('.price').text(),
                id = obj.attr('data-id');
            visitWeidian.addtocart({id:id, name:goods_name, price:price, image_src:image_src}, 1);
        },

		template: function(data) {
            var temp = _.template($('#product_tpl').html(), {collection: data, selectedProduct: window.selectedProduct});
            return temp;
        },

		render: function(state) {
            this.$('.productlist').html(this.template(this.collection.toJSON()));
        },

		chose:function(e){
			
		},

	});

	var newProduct = new NewProductView();

	return {
		init:function(product_id){
			selectedSelected = product_id;
			newProduct.collection.fetch();
		}
	}
});

