define(function(require) {
    $('html, body').height('auto');
    
    var apiUrl = require('../apiConfig');

    var curStep;
    var orderStatus=3;

    var OrderList = Backbone.Collection.extend({
        url: apiUrl.addr + '?r=store.myorder.list',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    status: orderStatus
                },
                success: function(data) {
                    if (data.success) {
                        self.reset(data.orders);
                        //显示页面
                        require.async('../nav', function(nav) {
                            nav.init(curStep);
                        });
                        $('#loading').fadeOut(200);
                        if (orderStatus == 3) {
                            if (data.orders.length == 0) {
                                $('.orders_no').hide();
                            }
                            else if (data.orders.length > 20) {
                                $('.orders_no').text("20+").show();
                            }
                            else {
                                $('.orders_no').text(data.orders.length).show();
                            }
                        }
                    } else {
                        self.goBackUrl();
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    self.goBackUrl();
                    $('#loading').fadeOut(200, function(e) {
                        alert(e.msg || '请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        goBackUrl: function() {
            app_router.navigate('!findMyWeidian/1', {trigger: false});
        }
    });

    var OrderView = Backbone.View.extend({
        el: '#orders',

        collection: new OrderList(),

        initialize: function() {
            var self = this;
            //监听 collection reset 事件
            // this.collection.on('reset', function() {
            //     self.render(1);
            // });
            this.collection.on('reset', this.render, this);

            var width = ($(window).width() * 0.9 - 240)/3;
            $('#shareLayer li').css('margin-left', width);


            $('#shareLayer .cancel').on('touchstart', function() {
                $(this).addClass('taped');
            });

            $('#shareLayer .cancel').on('touchend', function() {
                $(this).removeClass('taped');
            });

            $('#shareLayer .cancel').on('click', function() {
                $('#shareLayer').fadeOut(400);
                $('#myWeidian').removeClass('blur_effect');
                $('nav').removeClass('blur_effect');
            });

            $('#shareLayer').on('touchstart', 'li', function(e) {
                var obj = $(e.target);
                obj.addClass('taped');
            });

            $('#shareLayer').on('touchend', 'li', function(e) {
                var obj = $(e.target);
                obj.removeClass('taped');
            });
        },

        template: function(collection) {
            var temp = _.template($('#orders_list_tpl').html(), {collection: collection});
            return temp;
        },

        render: function(data) {
            if (orderStatus == 3) {

            }
            this.$('.orders_list').html(this.template(this.collection.toJSON()));
            // if (state == 0) {
                
            // } else if (state == 1) {
                
            // } else {
            //     this.$('.goods_list').html(this.c_template(data));
            //     this.$('.goods_no').text(data.length);
            // }
        },

        events: {
            'click .order': 'toDetailView',
            'click .first': 'listOrder',
            'click .second': 'listOrder',
            'click .third': 'listOrder',
            'click .last': 'listOrder'
        },

        listOrder: function(e) {
            var obj = $(e.currentTarget);
            obj.parent().children().removeClass('actived');
            obj.addClass('actived');
            orderStatus = obj.data('status');
            this.collection.fetch();
        },

        toDetailView: function(e) {
            var obj = $(e.currentTarget);
            sessionStorage.order_id = obj.attr('data-id');
            app_router.navigate('!order_detail/' + sessionStorage.order_id, {trigger: true});
        },

        tapBg: function() {
            $('.share').addClass('taped');
        },

        notapBg: function() {
            $('.share').removeClass('taped');
        },

        toggleEffect: function(e) {
            var obj = $(e.currentTarget);
            obj.addClass('taped').siblings().removeClass('taped');
        },

        taped: function(e) {
            var obj = $(e.target);
            obj.addClass('taped');
        },

        notap: function(e) {
            var obj = $(e.target);
            obj.removeClass('taped');
        }
    });

    var ordersView = new OrderView();

    return {
        init: function(step) {
            if (step != '2') {
                curStep = step;
                $('#loading').fadeIn(200);
                ordersView.collection.fetch();
            } else {
                require.async('../nav', function(nav) {
                    nav.init(step);
                });
            }
        }
    };
});