define(function(require,exports,module){
	var curStep=0;
	var apiUrl = require('../apiConfig');
    var visitWeidian = require('./enterWeidian');
    var productInfo;

	var ProductUpdater = Backbone.Collection.extend({
        url: apiUrl.addr + '?r=customer.product.search',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'get',
                data: {
                    mobile_no: sessionStorage.keyword
                },
                success: function(data) {
                    if (data.success) {
                        pl = data.product_list;
                        self.reset(data.product_list);
                        //显示页面
                        require.async('../nav', function(nav) {
                            nav.init(curStep, ntText);
                        });
                        $('#loading').fadeOut(200);
                    } else {
                        self.goBackUrl();
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    $('#loading').fadeOut(200, function(e) {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        goBackUrl: function() {
            app_router.navigate('!enterWeidian/1', {trigger: true});
        }
    });

	var NewProductView=Backbone.View.extend({
        el:'#newproduct',

        events:{
            'tap .productlist li': 'productSelect',
            'tap .sear': 'dataTransfer',
        },

        collection: new ProductList(),

        initialize: function() {
            var self = this;
            this.collection.on('reset', function() {
                self.render();
            });
            this.render();                     
        },

        productSelect: function(e) {
            var obj = $(e.currentTarget);
            var goods_name = obj.children('.name').text(),,
                price = obj.children('.price').text(),
                id = "tmp" + obj.attr('data-id'),
                                            image_src="";
            visitWeidian.addtocart({id:id, name:goods_name, price:price, image_src:image_src}, 1);
        },

        template: function(data) {
            var temp = _.template($('#product_tpl').html(), {collection: data, selectedProduct: window.selectedProduct});
            return temp;
        },

        render: function(state) {
            this.$('.productlist').html(this.template(this.collection.toJSON()));
        },

        chose:function(e){
            
        },

    });

	var addProduct = new AddProductView();

	return{
		init:function(step){
			addProduct.render();
		}
	}
});