define(function(require) {
    var apiUrl = require('../apiConfig');
    var detail = [];
    var amount;
    var pId;
    if(localStorage.le<2){
        $("#settlement .one").hide();
    }
    
    var OrderInfo = Backbone.Model.extend({
        url: apiUrl.addr + '?r=store.order.submit',
        sync: function() {
            var self = this;
            $.ajax({
                url: this.url,
                type: 'post',
                data: {
                    mobile_no: sessionStorage.mobile_no,
                    payer_id: context.user.mobileNo,
                    detail: JSON.stringify(detail),
                    amount: amount,
                    needexpress: $("#settlement .right").hasClass("open") ? "1" : "0",
                    address: JSON.stringify(window.selectedAddress || ""),
                    memo:$("#settlement .msg").val()
                },
                success: function(data) {
                    if (data.success) {
                        $('#loading').fadeOut(200);
                        self.requestOrder(data.order);
                    } else {
                        $('#loading').fadeOut(200, function() {
                            alert(data.msg, function() {}, '提示', '确定');
                        });
                    }
                },
                error: function() {
                    $('#loading').fadeOut(200, function() {
                        alert('请检查当前网络', function() {}, '提示', '确定');
                    });
                }
            });
        },
        requestOrder: function(data) {
            if(sessionStorage.buytype == null) {
                alert("订单已过期，请返回后首页后重新下单");
                return;
            }
            jfpal.jfPay({
                "needHandsign": '1',
                "merchantId": "0002000002",
                "merchantName": '福店',
                "productId": sessionStorage.buytype,
                "orderAmt": (data.amount * 100).toFixed(0) + '',
                "orderDesc": sessionStorage.mobile_no, //微店主手机号
                "orderRemark": localStorage.appUser + "," + data.id //flagship_id,order_id  更改内容
                        },function(o){
                        app_router.navigate('!findWeidian/2', {trigger: true});
                        },function(){
                        
                        });
        }
    });
       
    var SettlementView = Backbone.View.extend({
        el: '#settlement',

        model: new OrderInfo(),

        initialize: function() {

        },

        template: function(data) {
            var temp = _.template($('#orderInfo_tpl').html(), {data: data});
            return temp;
        },
        a_template: function(data) {
            var temp = _.template($('#address_bottom_tpl').html(), {address: data});
            return temp;
        },

        shopTrl: '',
 
        render: function(data) {
            this.$('.last').html(this.template(data));
            
            this.shopTrl = data;

            this.render_bottom(data);

            if (sessionStorage.buytype == "0000000000") {
                pId = '0000000000';
                context.helpinfo('PersonalPayments.PayWaySuper', function(data){
                    $('.notice').html(data);
                    $('#payway').html('会员批发');
                });
            }
            if (sessionStorage.buytype == "0000000002") {
                pId = '0000000002';
                context.helpinfo('PersonalPayments.PayWayCommon', function(data){
                    $('.notice').html(data);
                    $('#payway').html('会员零购');
                });
            }
        },

        render_bottom: function() {
            var data = {
                "name": "",
                "tel": "",
                "privince": "",
                "address": "",
            };
            if (window.selectedAddress) {
                $("#settlement .right").addClass("open");
                $("#settlement .bottom").show();
                data = window.selectedAddress;
            }
            else {
                $("#settlement .right").removeClass("open");
                $("#settlement .bottom").hide();
            }
            this.$('.bottom').html(this.a_template(data));
            
        },


        events: {
            'click .global_button': 'settle',
            //'click .fourth span': 'chsStyle',
            'touchstart .global_button': 'taped',
            'touchend .global_button': 'notap',
            'touchstart .pub_goods': 'taped',
            'touchend .pub_goods': 'notap',
            'tap .six .right':'opclo',
            'tap .bottom':'toaddaddress'
        },

        settle: function() {
            var i = 0;
            $.each(this.shopTrl, function(key, value) {
                detail[i] = [];
                detail[i][0] = value[0]['id'];
                detail[i][1] = value[0]['price'];
                detail[i][2] = value.length;
                i += 1;
            });
            
            var productAmount = parseInt($('.order_price, .trolley_icon > span').text());
            if (productAmount < 10 && sessionStorage.buytype == '0000000000') {
                alert('购买10件商品以上才可享受批发优惠', function() {}, '提示', '确定');
                return;
            }

            $('#loading').fadeIn(200);
            this.model.save();
        },

        chsStyle: function(e) {
            //
            
        },

        taped: function(e) {
        	var obj = $(e.target);
        	obj.addClass('taped');
        },

        notap: function(e) {
        	var obj = $(e.target);
        	obj.removeClass('taped');
        },

        opclo:function(e){
            var obj = $(e.currentTarget);
            if (obj.hasClass('open')) {
                obj.removeClass("open");
                $("#settlement .bottom").hide();
            }
            else {
                app_router.navigate('!newaddress/4', {trigger:true});
            }
        },

        toaddaddress:function(e){
            var obj = $(e.currentTarget);
            app_router.navigate('!newaddress/' + $(obj).data('address_id'), {trigger:true});
        }
        
    });

    var settlementView = new SettlementView();

    return {
        init: function(step) {
            amount = sessionStorage.amount;
            $('#settlement .second span').text('¥ ' + amount);
            $('.fourth .right').addClass('taped').siblings('.left').removeClass('taped');
            pId = '0000000002';
            context.helpinfo('PersonalPayments.PayWayCommon', function(data){
                $('.notice').html(data);
            });
            settlementView.render(JSON.parse(sessionStorage.shopTrl));
        }
    };
});
